
--	Automat_BuildTools.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.0
--	CREATED:	01-127-2012 --3dsmax 2012

(
	global automat_CoordinateGridNames
	global Roll_automat_CoordinateGridNames
	
	local CurrentINI = GetDir #plugcfg + "\\automat_CoordinateGridNames.ini"
	
		--
	local RolloutPosition= [200,200]
	
	getapref = execute ( getINISetting CurrentINI "Coordinate Grid Names" "RolloutPosition" )
			if getapref != OK do RolloutPosition = getapref
	
	--
	
	local nameRowsAndColumns
	local sortByValues
	local sortObjectsForX
	
	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout Roll_automat_CoordinateGridNames "Coordinate Grid Names"
	(
		group "Coordinate Grid Names:"
		(
			button but_NameRowsAndColumns "Rename Selected"
			edittext text_GridPrefix "Prefix:" text:"Map" width:121 offset:[10,0]
			edittext text_GridPreview "Preview:" readonly:true text:"Map_A_1"
		)
		
		
				--BUTTONS
		--/////////////////////////////////////////////
		--------------------------------------------------------
		--------------------------------------------------------
		on Roll_automat_CoordinateGridNames moved ScreenPos do
		(
			setapref =  setINISetting CurrentINI "Coordinate Grid Names" "RolloutPosition" (ScreenPos as string )
		)
		
		
		--Rollout Collapsifier
		--------------------------------------------------------
		on Roll_automat_CoordinateGridNames rolledUp state do
		(
			if false == state then --minimize
			(
				try(automat_CoordinateGridNames.size.y = 24)catch()
			)
			else
			(
				try( automat_CoordinateGridNames.size.y = ( Roll_automat_CoordinateGridNames.height + 30 ) )catch()
			)	
		)
		--
		
		on text_GridPrefix changed value do
		(
			text_GridPreview.text = value + "_A_1"
		)
		
		--
		
		on but_NameRowsAndColumns pressed do
		(
			nameRowsAndColumns selection text_GridPrefix.text
		)
		
	

	) --END ROLLOUT
	
	
	
	--------------------------------------------------------
	
		local ObjRows=#()
	local ListOfYs=#()
	local CoordArray=#("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z")
	
	--------------------------------------------------------
	function nameRowsAndColumns selection userstring =
	(
		ObjRows=#()
		ListOfYs=#()
		--
		ObjArray = for each in selection where isvalidnode(each) collect each
		--
		--get objects with similar y values
		for each in ObjArray do
		(
			simpleY = floor( each.position.y * 100 ) --knock down precision somehow
			format "simpleY: %\n" simpleY
			
			appendIfUnique ListOfYs simpleY --yah, this is a lifesaver
		)
		qsort ListOfYs sortByValues --should put the y values into far to near order
		format "ListOfYs: %\n" ListOfYs
		
		ycount = ListOfYs.count -- this is the number of rows
		
		--assign each object to a row
		for rowloop = 1 to ycount do
		(
			temprow=#()
			temprow = for each in ObjArray where floor( each.position.y * 100 ) == ListOfYs[rowloop]  collect each
			--temprow = for each in ObjArray where (close_enough each.pos.y  ListOfYs[rowloop] 10) collect each
			qsort temprow sortObjectsForX
			
			append ObjRows temprow
		)
		
		--rename
		for outloop = 1 to ycount do --for each row
		(
-- 			--Row Naming
			alphloop = ceil (outloop/26.0) --alphabet integer
			b = outloop - (alphloop - 1)*26
			
			local letter = CoordArray[b]
			--
			rowname = ""
			for charloop = 1 to alphloop do
			(
				rowname += letter
			)
			rowname += "_"
			--rowname = outloop as string + "_"
			
			for inloop = 1 to ObjRows[outloop].count do --for each column
			(
				ObjRows[outloop][inloop].name = userstring + "_" + rowname + inloop as string
			)
			
			
		)
	)
	
	--------------------------------------------------------
	function sortByValues v1 v2=
	(
		local CompareTestValue = (v1)-(v2)
		case of
		(
			(CompareTestValue < 0.): 1
			(CompareTestValue > 0.): -1
			default: 0
		)
	)
	--------------------------------------------------------
	function sortObjectsForX v1 v2=
	(
		local CompareTestValue = (v1.position.x)-(v2.position.x)
		case of
		(
			(CompareTestValue < 0.): -1
			(CompareTestValue > 0.): 1
			default: 0
		)
	)
		
		
		--------------------------------------------------------
		--------------------------------------------------------
	
	
	if true != automat_OpenScriptAsRollout then
	(
		try (closeRolloutfloater automat_CoordinateGridNames ) catch ()
		automat_CoordinateGridNames = newRolloutFloater "Coordinate Grid Names" 170 102 RolloutPosition.x RolloutPosition.y
		addRollout Roll_automat_CoordinateGridNames automat_CoordinateGridNames
		automat_CoordinateGridNames.size.y = ( Roll_automat_CoordinateGridNames.height + 30 )
	)
	else()
)