
--	Eolith.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.0
--	CREATED:	02-19-2011 --3dsmax 2011
--	MODIFIED:	02-19-2011 --3dsmax 2011

--------------------------------------------------------

(
	global automat_GoldenRatio
	--------------------------------------------------------
	local FibNumArray=#()

	
	--------------------------------------------------------
	local CurrentINI = GetDir #plugcfg + "\\automat_GoldenRatio.ini"
	
		--
	local RolloutPosition= [200,200]
	
	getapref = execute ( getINISetting CurrentINI "Golden Ratio" "RolloutPosition" )
			if getapref != OK do RolloutPosition = getapref
	
	--------------------------------------------------------
			
			
	--Function Names
	--------------------------------------------------------
	local getFibSeries



	rollout roll_automat_GoldenRatio "Golden Ratio"
	(
		group "Golden Ratio:"
		(
			edittext text_GoldNumber "Enter a number:"  bold:true tooltip:"Enter a number and to numbers that match the golden ratio"
			edittext text_Gold1a "" text:"-" readonly:true width:60 offset:[5,0] across:2
			edittext text_Gold2a "" text:"-" readonly:true width:60
			edittext text_Gold1b "" text:"-" readonly:true width:60 offset:[5,0] across:2
			edittext text_Gold2b "" readonly:true width:60 bold:true
			edittext text_Gold1c "" readonly:true width:60 bold:true offset:[5,0] across:2
			edittext text_Gold2c "" text:"-" readonly:true  width:60	
		)
		
		group "Fibonacci Series:"
		(
			edittext text_FibNumber "Enter a number:"  bold:true value:1
			edittext text_Fib1 "" text:"-" readonly:true width:52 offset:[-10,0] across:3
			edittext text_Fib2 "" text:"-" readonly:true width:52 bold:true offset:[-5,0]
			edittext text_Fib3 "" text:"-" readonly:true width:52
		)
		
		
		--Rollout Collapsifier
		--------------------------------------------------------
		on roll_automat_GoldenRatio rolledUp state do
		(
			if false == state then --minimize
			(
				try(automat_GoldenRatio.size.y = 24)catch()
			)
			else
			(
				try( automat_GoldenRatio.size.y = ( roll_automat_GoldenRatio.height + 30 ) )catch()
			)	
		)
		
		
		on roll_automat_GoldenRatio moved ScreenPos do
		(
			setapref =  setINISetting CurrentINI "Golden Ratio" "RolloutPosition" (ScreenPos as string )
		)
		
		
		on text_GoldNumber entered UserData do
		(
			UserData = UserData as float
			
			if UserData != undefined then
			(
				local oneoverphi = "-"
				local remainder = "-"
				local phi = "-"
				
				if UserData != 0 do
				(
					--calculate 1/phi
					oneoverphi = UserData * 0.618
					remainder = UserData - oneoverphi
					phi = UserData * 1.618
				)
				
				--put number in context
				text_Gold1c.text = UserData as string
				text_Gold2b.text = UserData as string
				
				text_Gold1a.text = remainder as string
				text_Gold1b.text = oneoverphi as string
				
				
				text_Gold2a.text = oneoverphi as string
				text_Gold2c.text = phi as string
			)
			else 
			(
				messagebox "Please enter a number."
				text_GoldNumber.text = ""
			)
		)
		
		on text_FibNumber entered UserData do
		(
			getFibSeries UserData
			text_Fib1.text = FibNumArray[1] as string
			text_Fib2.text = FibNumArray[2] as string
			text_Fib3.text = FibNumArray[3] as string
		)
	)
				
	--------------------------------------------------------
	function getFibSeries UserData =
	(
		local checkuserdata = UserData as integer
		if checkuserdata != undefined then
		(
			if 0 == checkuserdata then FibNumArray =#( "-", 0, 1 )
				else if 1 == checkuserdata then FibNumArray =#( 0, 1, 1 )
					else
					(
						checkuserdata = abs checkuserdata
						oldnumber = 1
						thisnumber = 2
						newnumber = 3
						while checkuserdata > thisnumber do
						(
							oldoldnumber = oldnumber
							oldnumber = thisnumber
							thisnumber = newnumber
							newnumber = oldnumber + thisnumber
						)
						if ( checkuserdata - oldnumber ) < ( thisnumber - checkuserdata ) \
							then FibNumArray =#( oldoldnumber, oldnumber, thisnumber )
						else FibNumArray =#( oldnumber, thisnumber, newnumber )
					)
		)
		else 
		(
			messagebox "numbers only please."
			FibNumArray =#( "-", "-", "-" )
		)	
	)

	if true != automat_OpenScriptAsRollout do
	(
		try (closeRolloutfloater automat_GoldenRatio ) catch ()
		automat_GoldenRatio = newRolloutFloater "Golden Ratio" 170 221 RolloutPosition.x RolloutPosition.y
		addRollout roll_automat_GoldenRatio automat_GoldenRatio
		automat_GoldenRatio.size.y = ( roll_automat_GoldenRatio.height + 30 )
	)
)