
--	ImplantObjects.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.0
-- MODIFIED:	01-27-12 --3dsmax 2012
--	CREATED:	5-11-11 --3dsmax 2011

(
	global automat_ImplantObjects
	local CurrentINI = GetDir #plugcfg + "\\automat_ImplantObjects.ini" 
	
	--
	local RolloutPosition= [200,200]
	
	getapref = execute ( getINISetting CurrentINI "Implant Objects" "RolloutPosition" )
			if getapref != OK do RolloutPosition = getapref
	
	--
	
	local implantSelected
	local enableImplantation
	
	local TargetArray
	local PlantArray
	
	rollout roll_automat_ImplantObjects "Object Tools"
	(
			group "Implant Objects:"
		(
			label label_Plants "Planting Objects:" offset:[3,0]
			button but_Plants "set" width:28 height:20 across:2 offset:[-22,-1]
			edittext text_Plants "" readonly:true text:"-" width:110 offset:[-40,0] 
			--
			label label_Target "Target Object:" offset:[3,0]
			button but_Target "set" width:28 height:20 across:2 offset:[-22,-1]
			edittext text_Target "" readonly:true text:"-" width:110 offset:[-40,0] 
			--
			button but_Implant "Implant!" height:24 offset:[0,4] enabled:false
		)
	
	
		--------------------------------------------------------
		
		on roll_automat_ImplantObjects open do
		(
			
		)
		
		on roll_automat_ImplantObjects moved ScreenPos do
		(
			setapref =  setINISetting CurrentINI "Implant Objects" "RolloutPosition" (ScreenPos as string )
		)
		
		
		--Rollout Collapsifier
		--------------------------------------------------------
		on roll_automat_ImplantObjects rolledUp state do
		(
			if false == state then --minimize
			(
				try(automat_ImplantObjects.size.y = 24)catch()
			)
			else
			(
				try( automat_ImplantObjects.size.y = ( roll_automat_ImplantObjects.height + 30 ) )catch()
			)	
		)

		--------------------------------------------------------
		
		
		on but_Plants pressed do
		(
			PlantArray=undefined
			
			if undefined != selection then
			(
				--
				PlantArray = for each in selection where isValidNode(each) collect each
				plantcount = PlantArray.count
				--
				planttext = if undefined == PlantArray or 0 == plantcount then "-"
				else if 1 == plantcount then PlantArray[1].name as string
					else plantcount as string + " Objects"	
				
				
				roll_automat_ImplantObjects.text_Plants.text = planttext
				--
				
			)
			else messagebox "Select one or more objects first."
			--
			enableImplantation()
		)
		
		--
		--------------------------------------------------------
		on but_Target pressed do
		(
			TargetArray=undefined
			
			if 1 == selection.count then
			(
				TargetArray = for each in selection where GeometryClass == superClassOf(each) collect each
				if 1 == TargetArray.count then
				(
					roll_automat_ImplantObjects.text_Target.text = TargetArray[1].name as string
				)
				else
				(
					roll_automat_ImplantObjects.text_Target.text = "-"
					messagebox "Please choose a geometry object as a target"
				)

			)
			else
			(
				roll_automat_ImplantObjects.text_Target.text = "-"
				messagebox "Select one or more objects first."
			)
			--
			enableImplantation()
		)
		
		on but_Implant pressed do
		(
			implantSelected selection
		)
		
	)
		
		
		
		
	--------------------------------------------------------
	--------------------------------------------------------
		--basic function comes from maxscript help file
	fn find_intersection z_node node_to_z =
	( 
		local testRay = ray node_to_z.pos [0,0,-1] 
		local nodeMaxZ = z_node.max.z 
		testRay.pos.z = nodeMaxZ + 0.0001 * abs nodeMaxZ 
		intersectRay z_node testRay 
	)
	

	--------------------------------------------------------
	function enableImplantation =
	(
		if undefined != TargetArray and undefined != PlantArray then
		(
			roll_automat_ImplantObjects.but_Implant.enabled = true
		)
		else 
		(
			roll_automat_ImplantObjects.but_Implant.enabled = false
		)
		
	)
	--------------------------------------------------------
	function implantSelected selection =
	(
		target_mesh = TargetArray[1]
		
		if isValidNode target_mesh then
		(
			undo "MoveToSurface" on
			(
				for each in PlantArray do
				(
					int_point = find_intersection target_mesh each
					if int_point != undefined then each.pos = int_point.pos
				)
			)
			
		 )
	)
	
		--------------------------------------------------------
	if true != automat_OpenScriptAsRollout do
	(
		try (closeRolloutfloater automat_ImplantObjects ) catch ()

		automat_ImplantObjects = newRolloutFloater "Implant Objects" 170 90 RolloutPosition.x RolloutPosition.y
		addRollout roll_automat_ImplantObjects automat_ImplantObjects
		automat_ImplantObjects.size.y = ( roll_automat_ImplantObjects.height + 30 )
	)
)
	
	