
--	JumbleTools.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.2
--	CREATED:	02-19-2011 --3dsmax 2011

--4-1-2014	Added ability to add Original Objects to a new, hidden layer, defaul option set to select original objects after an operation
--2-5-12	Fixed the jumble only button, streamlined interface


(
	global automat_JumbleTool
	global roll_automat_JumbleTool
	local JumblePrefs
	
	--------------------------------------------------------
	if true != BurkeLibLoaded do include "$userScripts/BurkeStudios/lib/BurkeLib.ms" 
	--------------------------------------------------------
	callbacks.addScript #selectionSetChanged "roll_automat_JumbleTool.enableMatchObject()" id:#automat_JumbleTool
	--------------------------------------------------------
	local CurrentINI = GetDir #plugcfg + "\\automat_JumbleTool.ini"
	
	local RolloutPosition= [200,200]
	
	getapref = execute ( getINISetting CurrentINI "Jumble Tool" "RolloutPosition" )
			if getapref != OK do RolloutPosition = getapref
	--------------------------------------------------------
	
	
	--Function Names
	--------------------------------------------------------
	local matchObject_automat
	local RepObjArr
	local ReplaceObjectInfo_mda
	local OrigObjArr
	local LastObjArr
	local newone --temp name of instanced objects, used for jumbling
	local jumbleScale
	local jumblePosition
	local jumbleRotation
	local updateJumbles
	local jumbleStuff
	local jumbleOnly
	
	struct struct_ReplaceObjects
	(
		replacemode = 1,
		randomseed = 14398221,
		sizematchmode = 3,
		bias =0,
		withoriginals = 1,
		jumbler = false,
		jumbles = false,
		jumblep = false,
		rx,ry,rz,
		sx,sx2,sy,sy2,sz,sz2,
		px,py,pz
	)
	
	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout roll_automat_JumbleTool "Replace and Jumble Tool"
	(
		group "Objects:"
		(
			label label_Originals "Originals:" offset:[-11,-2]
			button but_Originals "set" width:28 height:20 across:2 offset:[-22,-1]\
			tooltip:"Left-click to set your current object selection as the objects to be replaced\n
Right-Click to reset\n
Ctrl-Click to load last object replacements as the objects to be replaced"
			
			edittext text_Originals "" readonly:true text:"-" width:110 offset:[-40,0]
			--
			label label_Replacements "Replacements:" offset:[3,0]
			button but_Replacements "set" width:28 height:20 across:2 offset:[-22,-1]\
			tooltip:"Left-click to set your current object selection as the replacement objects\n
Right-Click to reset"
			
			edittext text_Replacements "" readonly:true text:"-" width:110 offset:[-40,0] 
			
			--
		)
		group "Replace Method:"
		(
			radiobuttons radio_ReplaceMode "" labels:#("ordered", "range","random","size-match") columns:1 offset:[0,0]\
			tooltip:"Ordered: replace objects in ordered, repeating sequence.\n
Range: If there are five objects in replacement array then the first object replaces the first 20% of objects, etc. The Range Bias shifts the distribution.\n
Random: Random\n
Size-Match: Quick and dirty attempt to replace objects with like-sized objects"
			
			radiobuttons radio_SizeMatchMode "Size-Match Mode:" labels:#("height","volume") columns:2 offset:[0,3] enabled:false
			--listbox list_Replacements "from"
			spinner spin_rangebias "range bias: " range:[-100,100,0] width:110 align:#center enabled:false\
			tooltip:""
		)
		group "Do with Original Objects:"
		(
			radiobuttons radio_WithOriginals "" labels:#("Select", "Hide","Hide on new layer","Delete") columns:1 offset:[-13,0]
		)
		--
		
		button but_ReplaceJumble "Replace 'n' Jumble" width:99 height:32 offset:[0,0] enabled:false
		button but_JumbleOnly "Jumble Only" width:99 height:20 offset:[0,0] enabled:false
		--
		group "Jumble Settings:"
		(
			checkbox check_JumbleR "Rotation (degrees)" checked:false
			spinner spin_XR "X: +/-" range:[0,180,15] width:75 align:#right offset:[2,0] enabled:false tooltip:""
			spinner spin_YR "Y: +/-" range:[0,180,15] width:75 align:#right offset:[2,0] enabled:false tooltip:""
			spinner spin_ZR "Z: +/-" range:[0,180,180] width:75 align:#right offset:[2,0] enabled:false tooltip:""
			--checkbox check_Step "step" align:#right checked:false
			--------------
			checkbox check_JumbleS "Scale (percent)" checked:false
			label lab_Scale "min      /      max" offset:[0,-3] enabled:false
			spinner spin_XS "x:" range:[1,500,80] width:70 across:2 offset:[-17,0] enabled:false tooltip:"" 
			spinner spin_XS2 "X:" range:[1,500,120] width:70 offset:[-10,0] enabled:false tooltip:"" 
			--
			spinner spin_YS "y:" range:[1,500,80] width:70 across:2 offset:[-17,0] enabled:false tooltip:""
			spinner spin_YS2 "Y:" range:[1,500,120] width:70 offset:[-10,0] enabled:false tooltip:"" 
			--
			spinner spin_ZS "z:" range:[1,500,80] width:70 across:2 offset:[-17,0] enabled:false tooltip:""
			spinner spin_ZS2 "Z:" range:[1,500,120] width:70 offset:[-10,0] enabled:false tooltip:"" 
			--------------
			checkbox check_JumbleP "Position (% obj. size)" offset:[0,5] checked:false
			--
			spinner spin_XP "X: +/-" range:[0,50,15] width:75 align:#right offset:[2,0] enabled:false tooltip:""
			spinner spin_YP "Y: +/-" range:[0,50,15] width:75 align:#right offset:[2,0] enabled:false tooltip:""
			spinner spin_ZP "Z: +/-" range:[0,50,0] width:75 align:#right offset:[2,0] enabled:false tooltip:""
		)
		
		
		on roll_automat_JumbleTool moved ScreenPos do
		(
			setapref =  setINISetting CurrentINI "Jumble Tool" "RolloutPosition" (ScreenPos as string )
		)
		
		
		--CALLBACK FUNCTION
		--/////////////////////////////////////////////
		--------------------------------------------------------
		function enableMatchObject = 
		(
			if selection.count > 0 then
			(
				but_Replacements.enabled = true
				but_Originals.enabled = true
			)
				else
			(
				but_Replacements.enabled = false
				but_Originals.enabled = false
			)
		)
	
		--REMOVE CALLBACK
		--CLOSE
		--/////////////////////////////////////////////
		--------------------------------------------------------
		on roll_automat_JumbleTool close do
		(
			callbacks.removeScripts #selectionSetChanged id:#automat_JumbleTool
		)
	
		--------------------------------------------------------
		function getJumblePrefsFromUI =
		(
			JumblePrefs = struct_ReplaceObjects replacemode:radio_ReplaceMode.state sizematchmode:radio_SizeMatchMode.state bias: spin_rangebias.value \
			withoriginals: radio_WithOriginals.state jumbler:check_JumbleR.state jumbles:check_JumbleS.state jumblep:check_JumbleP.state \
			rx:spin_XR.value ry:spin_YR.value rz:spin_ZR.value \
			sx:(spin_XS.value/100) sx2:(spin_XS2.value/100) sy:(spin_YS.value/100) sy2:(spin_YS2.value/100) sZ:(spin_ZS.value/100) sz2:(spin_ZS2.value/100) \
			px:(spin_XP.value/100) py:(spin_YP.value/100) pz:(spin_ZP.value/100)
		)
		
		
		--Rollout Collapsifier
		--------------------------------------------------------
		on roll_automat_JumbleTool rolledUp state do
		(
			if false == state then --minimize
			(
				try(automat_JumbleTool.size.y = 24)catch()
			)
			else
			(
				try( automat_JumbleTool.size.y = ( roll_automat_JumbleTool.height + 30 ) )catch()
			)	
		)
		
		--------------------------------------------------------
		function updateJumbles =
		(
			getJumblePrefsFromUI()
			if  undefined != OrigObjArr and ( JumblePrefs.jumbleR or JumblePrefs.jumbleS or JumblePrefs.jumbleP ) 
				then but_JumbleOnly.enabled = true
					else but_JumbleOnly.enabled = false
			
			if  undefined != OrigObjArr and undefined != RepObjArr
				then but_ReplaceJumble.enabled = true
					else but_ReplaceJumble.enabled = false
				
		
		)
		
		--------------------------------------------------------
		function jumbleScale =
		(
			if isValidNode newone do
			(
				--this function always jumbles the object named "newone"
				newone.scale.x *= ( random JumblePrefs.sx JumblePrefs.sx2)
				newone.scale.y *= ( random JumblePrefs.sy JumblePrefs.sy2)
				newone.scale.z *= ( random JumblePrefs.sz JumblePrefs.sz2)
			)
		)
		
		--------------------------------------------------------
		function jumbleRotation =
		(
			--this function always jumbles the object named "newone"
			if isValidNode newone do
			(
				in coordsys local
				(
					thex = ( random -JumblePrefs.rx  JumblePrefs.rx )
					they = ( random -JumblePrefs.ry  JumblePrefs.ry )
					thez = ( random -JumblePrefs.rz  JumblePrefs.rz )
					
					rotate newone (quat thez z_axis)
					rotate newone (quat they y_axis)
					rotate newone (quat thex x_axis)
					
				)
				--print "Jumble Rotation"
			)	
			
		)
		
		--------------------------------------------------------
		function jumblePosition thex they thez =
		(
			if isValidNode newone do
			(
				--this function always jumbles the object named "newone"
				
				newone.pos.x += thex * ( random -JumblePrefs.px JumblePrefs.px)
				newone.pos.y += they * ( random -JumblePrefs.py JumblePrefs.py)
				newone.pos.z += thez * ( random -JumblePrefs.pz JumblePrefs.pz)
				--print "JumbleP"
			)
		)
		
		--------------------------------------------------------
		function updateReplaceObjectsUI =
		(
			text_Originals.text = if undefined == OrigObjArr then "-"
				else if 1 == OrigObjArr.count then OrigObjArr[1].name as string
					else OrigObjArr.count as string + " Objects"
			text_Replacements.text = if undefined == RepObjArr then "-"
				else if 1 == RepObjArr.count then RepObjArr[1].name as string
					else RepObjArr.count as string + " Objects"
				
			--------------
			updateJumbles() 
		)
		
		
		
		--------------------------------------------------------
		--------------------------------------------------------
		--Jumble Stuff
		--------------------------------------------------------
		function jumbleStuff = 
		(
			
			getJumblePrefsFromUI()
			fromcount = RepObjArr.count
			tocount = OrigObjArr.count
			local NewOriginals=#()
			
			--store current transforms
			--------------------------------------------------------
			ReplaceObjectInfo_mda=#()
			for each in RepObjArr do
			(
				temparray=#()
				append temparray each.name 			--1
				--
				in coordsys local
				(
					x = each.max.x - each.min.x
					append temparray x						--2
					y = each.max.y - each.min.y
					append temparray y						--3
					z = each.max.z - each.min.z 
					append temparray z						--4	
					diagonal = distance each.min each.max
					append temparray diagonal			--5
				)
				polycount = if each.baseobject == Editable_Poly then each.numfaces else undefined
				append temparray polycount				--6	
				append ReplaceObjectInfo_mda temparray
			)
			
			--------------------------------------------------------
			--------------------------------------------------------
			local  stepper
			--setup percent step counter
			b = ( 1.0 * tocount )/fromcount --this is the value for an unadjusted stepcounter
			targetvalue = ( if JumblePrefs.bias <= 0 then 0 else tocount ) -- number bias value is seeking
			
			curval = abs ( JumblePrefs.bias / 100 )
			stepper = b * (1 - curval ) + ( targetvalue * curval )
			
	
			
			
			loop = fromloop = 1
			while loop <= tocount do
			(
				if 1 == JumblePrefs.replacemode do --ORDERED
				(
					if fromloop > fromcount do fromloop = 1
					newone = instance RepObjArr[fromloop]
					--
					newone.scale = OrigObjArr[loop].scale
					if JumblePrefs.jumbleS do jumbleScale() --jumble SCALE
					--
					newone.rotation = OrigObjArr[loop].rotation
					if JumblePrefs.jumbleR do jumbleRotation()
					--
					newone.pos = OrigObjArr[loop].pos
					append NewOriginals newone 
					fromloop += 1	
				)
				if 2 == JumblePrefs.replacemode do --RANGE
				(
					whichone = ceil  (loop/stepper)
					if whichone > fromcount then whichone = fromcount
-- 					format "loop %\n" loop
-- 					format "loop/stepper %\n" (loop/stepper)
-- 					format "stepper %\n" stepper
-- 					format "whichone %\n\n" whichone
					
					newone = instance RepObjArr[whichone]
					--
					newone.scale = OrigObjArr[loop].scale
					if JumblePrefs.jumbleS do jumbleScale() --jumble SCALE
					--
					newone.rotation = OrigObjArr[loop].rotation
					if JumblePrefs.jumbleR do jumbleRotation()
					--
					newone.pos = OrigObjArr[loop].pos
					append NewOriginals newone 
						
				)
				if 3 == JumblePrefs.replacemode do --RANDOM
				(
					pickanum = ( random 1 fromcount )
					newone = instance RepObjArr[pickanum]
					--
					newone.scale = OrigObjArr[loop].scale
					if JumblePrefs.jumbleS do jumbleScale() --jumble SCALE
					--
					newone.rotation = OrigObjArr[loop].rotation
					if JumblePrefs.jumbleR do jumbleRotation()
					--
					newone.pos = OrigObjArr[loop].pos
					append NewOriginals newone
				)
				if 4 == JumblePrefs.replacemode do --SIZE-MATCH
				(
					sizepick = JumblePrefs.sizematchmode
					in coordsys world
					(
						local selectanum = 1
						local lastdiff = 1000000
						
						
						for innerloop = 1 to fromcount do
						(
							if 2 == sizepick then --diag is a special case
							(
								thediff = abs ( ReplaceObjectInfo_mda[innerloop][5] - ( distance OrigObjArr[loop].min OrigObjArr[loop].max ) )	
							)
							else thediff = abs ( ( ReplaceObjectInfo_mda[innerloop][4] ) - ( OrigObjArr[loop].max[3] - OrigObjArr[loop].min[3] ) )
						
							
-- 							format "loop: %\n" loop
-- 							format "innerloop: %\n" innerloop
-- 							format "totaldiff: %\n" totaldiff
-- 							print "================="
							if thediff < lastdiff do selectanum = innerloop
							lastdiff = thediff
						)	
					)
					--------------
					newone = instance RepObjArr[selectanum]
					--
					if JumblePrefs.jumbleS do jumbleScale() --jumble SCALE
					newone.rotation = OrigObjArr[loop].rotation
					if JumblePrefs.jumbleR do jumbleRotation()
					--
					newone.pos = OrigObjArr[loop].pos
					if JumblePrefs.jumbleP do jumblePosition ReplaceObjectInfo_mda[selectanum][2] ReplaceObjectInfo_mda[selectanum][3] ReplaceObjectInfo_mda[selectanum][4]
					
					append NewOriginals newone
				)
				
				
				loop += 1
			)
			
			--------------------------------------------------------
			--what to do with original objects
			--------------------------------------------------------
			if 2 == JumblePrefs.withoriginals then for each in OrigObjArr do hide each
				else if 4  == JumblePrefs.withoriginals then for each in OrigObjArr do delete each
					else if 3 == JumblePrefs.withoriginals then
					(
						--let's layer up
						thelayer = LayerManager.newLayer()

						-- set layer's name
						tempname = "Replaced_001"
						tempcount = OrigObjArr.count
						loopy = 1
						
						while
						(
							false == ( thelayer.setname tempname )
						)
						do
						(
							--rejigger name
							loopy +=1
							loopytext = loopy as string
							if 1 == loopytext.count then padding = "00"
								else if 2 == loopytext.count then padding = "0"
									else padding = ""
							tempname = "ReplacedObjects_" + padding + loopytext
							
						)
						-- add nodes to layer from selection
						for n in OrigObjArr do thelayer.addnode n
						thelayer.ishidden = true
						

						--layer name was unique and new layer was created
						promptstring = tempcount as string + " objects hidden in new layer " + tempname +"."
						popPrompt()
						displayTempPrompt promptstring 2000

						
					)
					else
					(
						--the default option is to just select the original objects
						max select none
						select OrigObjArr
						
					)
					
			
			--------------------------------------------------------
			OrigObjArr=undefined
			LastObjArr=#()
			for each in NewOriginals do append LastObjArr each
			updateReplaceObjectsUI()
		)
		
		function jumbleOnly = 
		(
			getJumblePrefsFromUI()
			
			loopend = OrigObjArr.count
			
			for loop = 1 to loopend do
			(
				newone = OrigObjArr[loop]
				
				if isValidNode newone do
				(
					x = newone.max.x - newone.min.x
					y = newone.max.y - newone.min.y
					z = newone.max.z - newone.min.z 
					
					if JumblePrefs.jumbleS do jumbleScale()
					if JumblePrefs.jumbleR do jumbleRotation()
					if JumblePrefs.jumbleP do jumblePosition x y z
				)
			)
		)
		

		
		--------------------------------------------------------
		on radio_ReplaceMode changed state do
		(
			if 2 == state then spin_rangebias.enabled = true else spin_rangebias.enabled = false
			if 4 == state then radio_SizeMatchMode.enabled = true else radio_SizeMatchMode.enabled = false
		)
		
		-- OPEN
		--/////////////////////////////////////////////
		--------------------------------------------------------
		on roll_automat_JumbleTool open do
		(
			enableMatchObject()
			getJumblePrefsFromUI()
			--struct ObjCleanPrefsStruct (pivotmode=true, mats=true, parent=true, child=true, layer=true)
		)
		--------------
		on check_JumbleR changed state do
		(
			JumblePrefs.jumbleR = state
			--
			spin_XR.enabled = spin_YR.enabled = spin_ZR.enabled =  state
			updateJumbles()
		)
		--------------
		on check_JumbleS changed state do
		(
			JumblePrefs.jumbleS = state
			--
			lab_Scale.enabled = spin_XS.enabled = spin_XS2.enabled = spin_YS.enabled = spin_YS2.enabled = spin_ZS.enabled =  spin_ZS2.enabled = state
			updateJumbles()
		)
		--------------
		on check_JumbleP changed state do
		(
			JumblePrefs.jumbleP = state
			--
			spin_XP.enabled = spin_YP.enabled = spin_ZP.enabled = state
			updateJumbles()
		)
		--------------------------------------------------------
		on but_Replacements pressed do 
		(
			if undefined != selection then
			(
				RepObjArr=#()
				--
				RepObjArr = for each in selection where isValidNode(each) collect each
				--
				updateReplaceObjectsUI()
			)
			else messagebox "Select the from objects and then use the button to assign store your selection"
		)
		
		on but_Replacements rightclick do 
		(
				RepObjArr = undefined
				--
				updateReplaceObjectsUI()
			
		)
		
		--------------------------------------------------------
		on but_Originals pressed do 
		(
			if undefined != selection then
			(
				OrigObjArr = undefined
				
				if keyboard.controlpressed then
				(
					if LastObjArr != undefined do
					(
						OrigObjArr = for each in LastObjArr where isValidNode(each) collect each
					)
				)
				else
				(
					OrigObjArr = for each in selection where isValidNode(each) collect each
				)
				
				updateReplaceObjectsUI()
			)
			else messagebox "Select objects in your scene and then press button to store"
		)
		
		on but_Originals rightclick do 
		(
				OrigObjArr = undefined
				--
				updateReplaceObjectsUI()
			
		)
		
		--------------------------------------------------------

		
		on but_ReplaceJumble pressed do
		(
			jumbleStuff()
		)
		
		on but_JumbleOnly pressed do
		(
			jumbleOnly()
		)
		
		
		
		
		
		
			
	) --ROLLOUT
	

	
	
	if true != automat_OpenScriptAsRollout then
	(
		try (closeRolloutfloater automat_JumbleTool ) catch ()
		automat_JumbleTool = newRolloutFloater "Jumble Tool" 170 102 RolloutPosition.x RolloutPosition.y
		addRollout roll_automat_JumbleTool automat_JumbleTool
		automat_JumbleTool.size.y = ( roll_automat_JumbleTool.height + 30 )
	)
	else()
	
	
)
