
--	JunkBoxTool.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.4
--	CREATED:	01-05-2011 --3dsmax 2011
--	MODIFIED:	03-14-2011 --3dsmax 2011

--Edits
--3-12-11 fixed image gamma selection images
--3-5-11 created new junkbox images and code to account for proper display under different gamma settings
--	8-20-12	Added kludge for forcing system units to inches before saving and loading models

(
	global automat_JunkBoxTool
	
	local CurrentINI = GetDir #plugcfg + "\\Automat_JunkBoxTool.ini"
	--format "CurrentINI: %\n" CurrentINI

	local ObjArray
	
	if true != BurkeLibLoaded do include "$userScripts/BurkeStudios/lib/BurkeLib.ms"
	
	--------------
	
	
	
	local RolloutPosition= [200,200]
	
	
	getapref = execute ( getINISetting CurrentINI "Junk Box" "RolloutPosition" )
			if getapref != OK do RolloutPosition = getapref
	
			
	--------------
		
	--------------------------------------------------------
	local callDrawerPrepAndUpdateUI	--FUNCTION NAME

	--------------------------------------------------------
	
	local ObjectNamesInFile=#()
	local CurrentFileName=#()
	local JBPrefs=	#()
	local PointNumIndex=#()
	local JB_ScaleFactorForObject
	local setButtonStatesForJunkBoxUI
	local JB_ButStateVal
	local JB_DrawerOpenState = false
	local JB_GroupSwitch = false

	local JB_BoxName = ""
	local JB_DrawerName = ""
	local JB_BoxNum = 1
	local JB_DrawerNum = 1
	local JB_GotoBoxName = undefined
	local JB_GotoDrawerName = undefined

	local JB_FilesCount = 0
	local JB_DrawerCountMessage = ""
	local JBMaxSelectDim

	local JB_ActionMode
	local JB_Action
	local JB_UserText
	local filename=""
	local JunkCounterForRenameHack = 0
	local RenamesForObjectsInFile=#()

	local JB_FilePath = (getDir #scene ) + "\JunkBox\\"
	local JB_FilePathDefault = JB_FilePath
	format "JB_FilePath: %\n" JB_FilePath
	
	local JunkWarning = "- no directories found -"

	--Filepaths and names
	--------------
	local JB_BoxNames=#()
	local JB_DrawerNames=#()
	local JB_BoxPaths=#()
	local JB_DrawerPaths=#()

	local JB_RESET = false
	local ImageLocation =  (  (getdir #userScripts)+"\\BurkeStudios\\images" )
	
	
	--GET gamma safe image
	getThisImage = (  ImageLocation + "\\JunkBox_lil.bmp" )
	openAnyOldImageWithProperGamma getThisImage
	img_JunkBox = returnThisImageFromAutomat

	--Function Names
	--------------------------------------------------------
	local loadJB_Drawer
	local doIsolateDrawer
	local collectJB_BoxesAndDrawerNames
	local readyJB_Drawer
	local getScaleFactorForObject
	local addSelectedToCurrentDrawer
	local exportDrawerToOBJ
	local keepJB_SelectedObjects
	local updateJBMessageText
	local removeFromDrawer
	local doJBContainerAction
	local doIsolateDrawer
	local makeSomethingStupid

	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout roll_automat_JunkBoxTool "Junk Box"
			(
				group "Junk Box:"
				(
					imgtag img_JunkBox1 bitmap:img_JunkBox\
					tooltip: ( "Click to change location: "+ (JB_FilePath as string) ) \
					border:false transparent: [255,0,255] offset:[18,0]
			
					
				
					dropDownList drop_PickBox "Box:"  items:JB_BoxNames offset:[0,-2]
					
					ListBox drop_PickDrawer "Drawer:" items:JB_DrawerNames[drop_PickBox.selection ] \
						tooltip:"These are primitives I use a lot."
					edittext text_DrawerCount text:JB_DrawerCountMessage readonly:true enabled:true color:gray \
						width:124 alignment: #center offset:[2,-2]
					
					button but_LoadDrawer "Open Drawer"  width:135
					checkbutton checkbut_KeepJunkSelection "Get Selected"  width:135 checked:false enabled:false highlightColor:(color 75 183 89)
					
				)
				
				group "Add or Remove Items:"
				(
					button but_AddSelected \
						"Add Items" tooltip:"Left-click: Add selection as single item\n\nRight-click: Add each object or group separately" width:60 offset: [-5,0] across:2 
					button but_RemoveSelected "Remove Items" width:80 enabled:false offset:[1,0]
					
				)
				group "Isolate"
				(
					button but_JBIsolate "Isolate Drawer" enabled:false
				)
				
				group "Edit Containers:"
				(
					--checkbox check_JunkIsolate "Use Isolate Selection" checked:false	NOT REALLY USEFUL
					radiobuttons rad_BoxOrDrawer "" labels:#("Box","Drawer") default:2 tooltip:"" columns:2
					radiobuttons rad_WhatToDo "Choose an Action:" labels:#("Create","Rename","Delete") columns:1 tooltip:""
					edittext text_JBUserType text:"enter name" 
					button but_JBUserAction "Do It!" enabled:true
					
				)
				
				group "Unit Preferences:"
				(
					checkbox check_ForceInches "Force Inches" tooltip:"Force system units to inches before loading and saving objects. This ensures that objects stay a constant size from scene to scene." height:16 checked:true 
				)
				
				
				--------------------------------------------------------
				on img_JunkBox1 mousedown do
				(
					--prep 
					
				)
				on img_JunkBox1 click do
				(
					beebee=undefined
					beebee = getSavePath initialDir:JB_FilePath historyCategory:"automat_JunkBox" \
						caption:"Select the directory folder you'd like to use for Junkbox" 
					
					if undefined != beebee do
					(
						JB_FilePath = beebee + "\\"
						--------------
						JB_RESET = true
						collectJB_BoxesAndDrawerNames()
						
						JB_GotoBoxName = JB_BoxNames[1]
						--------------
						callDrawerPrepAndUpdateUI()
						--------------
						--SAVE LOCATION TO INI
						setapref =  setINISetting CurrentINI "Junk Box Prefs" "JB_FilePath" (  "\"" + JB_FilePath as string + "\"" )
						format "JB_FilePath: %\n" JB_FilePath
						--------------
					)					
				)
				
				--------------------------------------------------------
				
				
				on roll_automat_JunkBoxTool moved ScreenPos do
				(
					setapref =  setINISetting CurrentINI "Junk Box" "RolloutPosition" (ScreenPos as string )
				)
		
		
				--------------------------------------------------------
				on roll_automat_JunkBoxTool open do
				(
-- 					getapref = ( getINISetting CurrentINI "Junk Box Prefs" "JB_FilePath" ) as string
-- 					format "getapref: %\n" getapref
-- 					if getapref != OK do JB_FilePath = getapref
-- 					format "JB_FilePath: %\n" JB_FilePath
 					
				)
				
				
				--Rollout Collapsifier
				--------------------------------------------------------
				on roll_automat_JunkBoxTool rolledUp state do
				(
					if false == state then --minimize
					(
						try( automat_JunkBoxTool.size.y = 24 )catch()
					)
					else
					(
						try( automat_JunkBoxTool.size.y = ( roll_automat_JunkBoxTool.height + 30 ) )catch()
					)	
				)


				
				--------------------------------------------------------
				on drop_PickBox selected JB_BoxNum do with undo off
				(
					drop_PickDrawer.items = JB_DrawerNames[drop_PickBox.selection ]
					
					callDrawerPrepAndUpdateUI()
				)			
				
				
				--------------------------------------------------------
				on drop_PickDrawer selected JB_DrawerNum do with undo off
				(
					callDrawerPrepAndUpdateUI()			
				)			
			
				--------------------------------------------------------
				on but_LoadDrawer pressed do with undo off
				(
					if JB_DrawerOpenState == false then	--OPEN DRAWER
					(
						JB_DrawerOpenState= true
						but_LoadDrawer.text = "Close Drawer"
						loadJB_Drawer JB_BoxName JB_DrawerName JBPrefs
						setButtonStatesForJunkBoxUI true
					)
					
					else	--CLOSE DRAWER
					(
						JB_DrawerOpenState= false
						but_LoadDrawer.text = "Open Drawer"
						setButtonStatesForJunkBoxUI false
						clearSelection()
						keepJB_SelectedObjects selection
					)
						
				)
				
				--------------------------------------------------------
				on checkbut_KeepJunkSelection changed state do with undo off
				(
					JB_DrawerOpenState= false
					but_LoadDrawer.text = "Open Drawer"
					
					setButtonStatesForJunkBoxUI false
					
					keepJB_SelectedObjects selection	
				)
				
				--------------------------------------------------------
				on but_LoadDrawer rightclick do --JUST FOR TESTING
				(
					--makeSomethingStupid()
					--Export drawer as OBJS
					exportDrawerToOBJ JB_BoxName JB_DrawerName
				)
				
				--------------------------------------------------------
				on but_AddSelected rightclick do
				(
					JB_GroupSwitch = false
					addSelectedToCurrentDrawer JB_BoxName JB_DrawerName JB_FilesCount JB_GroupSwitch selection
				)
				on but_AddSelected pressed do
				(
					JB_GroupSwitch = true
					addSelectedToCurrentDrawer JB_BoxName JB_DrawerName JB_FilesCount JB_GroupSwitch selection
				)
				
				--------------------------------------------------------
				on but_RemoveSelected pressed do
				(
					removeFromDrawer JB_BoxName JB_DrawerName selection	
				)
				
				--------------------------------------------------------
				on but_JBUserAction pressed do
				(
					JB_ActionMode = rad_BoxOrDrawer.state
					JB_Action = rad_WhatToDo.state
					JB_UserText = text_JBUserType.text
					
					doJBContainerAction JB_ActionMode JB_Action JB_UserText JB_BoxName JB_DrawerName 
				)
				
				on but_JBIsolate pressed do
				(
					doIsolateDrawer()	
				)
					
			)

			--LOCAL FUNCTION FOR UI UPDATE
		--------------------------------------------------------
		fn setButtonStatesForJunkBoxUI JB_ButStateVal =
		(
			roll_automat_JunkBoxTool.checkbut_KeepJunkSelection.enabled = JB_ButStateVal
			roll_automat_JunkBoxTool.checkbut_KeepJunkSelection.checked = JB_ButStateVal
			
			roll_automat_JunkBoxTool.but_RemoveSelected.enabled = JB_ButStateVal
			roll_automat_JunkBoxTool.but_JBIsolate.enabled = JB_ButStateVal
			
			JB_DrawerOpenState = JB_ButStateVal
			
		)			
		
		--------------------------------------------------------
		fn callDrawerPrepAndUpdateUI = 
		(
			if JB_RESET do --SET UI to accomodate changes to directories
			(
				if JB_GotoBoxName != undefined then --SET BY BOX NAME
				(
					boxcount = JB_BoxNames.count
					
					if boxcount > 1 then 
					(
						while JB_BoxNames[boxcount] != JB_GotoBoxName and boxcount >=2 do boxcount -= 1
					)
					else boxcount =1
					
					roll_automat_JunkBoxTool.drop_PickBox.items = JB_BoxNames --Update list of box names
					roll_automat_JunkBoxTool.drop_PickBox.selection = boxcount --set current box to GotoBox
					--------------
					roll_automat_JunkBoxTool.drop_PickDrawer.items = JB_DrawerNames[ boxcount ]
					roll_automat_JunkBoxTool.drop_PickDrawer.selection = JB_DrawerNum
				)
				else --SET bY DRAWER NAME
				(
					roll_automat_JunkBoxTool.drop_PickDrawer.items = JB_DrawerNames[ JB_BoxNum ]
					drawercount =JB_DrawerNames[JB_BoxNum].count
					
					if drawercount > 1 then 
					(				
						while JB_DrawerNames[JB_BoxNum][drawercount] != JB_GotoDrawerName and drawercount >=2 do drawercount -= 1
					)
					else drawercount = 1
					
					roll_automat_JunkBoxTool.drop_PickDrawer.selection = drawercount --sets index to match found GotoDrawer name

				)
				--------------
				JB_RESET = false
			)
			
			--------------
			--COLLECT INFO FROM UI
			--------------
			JB_BoxName = roll_automat_JunkBoxTool.drop_PickBox.selected
			JB_BoxNum = roll_automat_JunkBoxTool.drop_PickBox.selection
			if JB_BoxNum > JB_BoxNames.count or undefined == JB_BoxNum or 0 == JB_BoxNum do
			(
				JB_BoxNum = 1
				JB_DrawerNames.count = JB_BoxNum
			)
				
			JB_DrawerName = roll_automat_JunkBoxTool.drop_PickDrawer.selected
			JB_DrawerNum = roll_automat_JunkBoxTool.drop_PickDrawer.selection
			if JB_DrawerNum > JB_DrawerNames[JB_BoxNum].count or undefined == JB_DrawerNum or 0 == JB_DrawerNum do
			(
				JB_DrawerNum = 1
				roll_automat_JunkBoxTool.drop_PickDrawer.selection = JB_DrawerNum
			)
			--------------
			readyJB_Drawer JB_BoxName JB_DrawerName
			--------------
			roll_automat_JunkBoxTool.text_DrawerCount.text = ( updateJBMessageText JB_FilesCount )
			--------------
			if undefined == JB_DrawerNames[JB_BoxNum][JB_DrawerNum] then
			(
				messagetext = ""
				roll_automat_JunkBoxTool.drop_PickDrawer.selection = 1 --?????
				roll_automat_JunkBoxTool.but_AddSelected.enabled = false --TURN OFF ADD BUTTON
			)
				else
			(
				messagetext = JB_DrawerNames[JB_BoxNum][JB_DrawerNum]
				roll_automat_JunkBoxTool.but_AddSelected.enabled = true	--TRUE IF THERE IS A DRAWER IN BOX
			)
				
				roll_automat_JunkBoxTool.text_JBUserType.text = messagetext	
				roll_automat_JunkBoxTool.img_JunkBox1.tooltip = JB_FilePath
		)

	--FUNCTIONS
	--/////////////////////////////////////////////
	--------------------------------------------------------
	fn collectJB_BoxesAndDrawerNames   =
	(
	--	This function refreshes list of box and drawer names by scanning the Junkbox directories
		
		--CLEAR ALL ARRAYS
		--The following arrays are set by this function
		--and used bythe other Junk Box functions.
		JB_BoxNames=#()
		JB_DrawerNames=#()
		JB_BoxPaths =#()
		JB_DrawerPaths=#()
		--------------
		
		--print PolyGPrefsCollection
		
		--Collect paths for each BOX directory
		--format "JB_FilePath: %\n" JB_FilePath
		JB_BoxPaths = getDirectories ( JB_FilePath + "*" ) --Array of paths to BOXES
		--format "JB_BoxPaths: %\n" JB_BoxPaths
		
		boxloopend = JB_BoxPaths.count
		
		if 0 != boxloopend then
		(
			for boxloop = 1 to boxloopend do --DO TASKS FOR EACH BOX
			(
				jb_drawerpathstemp=#() --reset arrays at start of each loop
				jb_drawernamestemp=#()
				
				JB_BoxNames[boxloop] = getTheLastElementNameInFileAddress JB_BoxPaths[boxloop] --Get the last directory in each path and use as box name
				jb_drawerpathstemp = getDirectories ( JB_BoxPaths[boxloop] + "*" ) --COLLECT ARRAY of drawer paths
				--format "jb_drawerpathstemp: %\n" jb_drawerpathstemp
				append JB_DrawerPaths jb_drawerpathstemp -- MULTI-DIMENSIONAL ARRAY of drawer paths
				
				innerloopend = JB_DrawerPathsTemp.count
				if 0 != innerloopend then
				(
						for innerloop = 1 to innerloopend do 
					(
						append jb_drawernamestemp ( getTheLastElementNameInFileAddress jb_drawerpathstemp[innerloop] ) --PATHS TO NAMES
					)
					
					append JB_DrawerNames jb_drawernamestemp --MULTI-DIMENSIONAL ARRAY
				)
				else
				(
					--NO DIRECTORIES (Drawers) in this box
					append JB_DrawerNames #( JunkWarning ,"") --!!!!!!!!!!!!!!!!!!!
				)
				
			)
		)
		else 
		(
			print "no items in directory"
	-- 		JB_BoxNames=#()
	-- 		JB_DrawerNames=#()
			
			
		)

			
	)

	--------------------------------------------------------	
	fn readyJB_Drawer JB_BoxName JB_DrawerName =
	(
		CurrentFileName = #()	--RESET ARRAY
		
		CurrentFileName = getFiles ( JB_FilePath + (JB_BoxName as string) + "\\" + (JB_DrawerName as string) + "\*.max" )
		JB_FilesCount = CurrentFileName.count
		
	)	

	--------------------------------------------------------
	fn getScaleFactorForObject GridSpacing selection =
	(
		JBMaxSelectDim = distance selection.max  selection.min
		JB_DimTarget = GridSpacing * 1.1 --SOME BUFFER
		JB_ScaleFactorForObject = if JB_DimTarget < JBMaxSelectDim then JB_DimTarget / JBMaxSelectDim
			else  JB_DimTarget / JBMaxSelectDim 
		--format "JBMaxSelectDim: %\n" JBMaxSelectDim
		--format "JB_ScaleFactorForObject: %\n" JB_ScaleFactorForObject
	)

	--------------------------------------------------------
	fn addSelectedToCurrentDrawer JB_BoxName JB_DrawerName JB_FilesCount JB_GroupSwitch selection =
	(
		if selection.count >0 do
		(
			
			--unit scale checks
			if roll_automat_JunkBoxTool.check_ForceInches.checked do
			(
				usersystemunittype = units.systemType
				units.systemType = #inches
			)
			
			
			--
		
			undo off
			(
				ObjArray = for piggy in selection where true == isValidNode piggy collect piggy
				clearSelection()
				select ObjArray
				LoopOffset = 0 --WILL INCREMENT AS NEEDED TO FIND AVAILABLE FREE FILENAME
				
				if false == JB_GroupSwitch then --SAVE OBJECTS INDIVIDUALLY
				(
					looplimit = ObjArray.count
					
					for loop = 1 to looplimit do
					(
						TempPos = ObjArray[loop].position --Orig POSITIONS
						ObjArray[loop].position = [0,0,0]
						
						--Cuku()
						
						filename = JB_FilePath + (JB_BoxName as string) + "\\" + (JB_DrawerName as string) + "\\" + ( ( JB_FilesCount + loop + LoopOffset ) as string ) + ".max"
						
						while (doesfileexist filename) --FILE EXISTS, GOTTA DO SUMPTHIN"
						
							do    	
							(
								LoopOffset+=1
								filename = JB_FilePath + (JB_BoxName as string) + "\\" + (JB_DrawerName as string) + "\\" + ( ( JB_FilesCount + loop + LoopOffset ) as string ) + ".max"
							)
										
						saveNodes ObjArray[loop] filename
						
						
						
						ObjArray[loop].position = TempPos
					)
				)
				else	--SAVE GROUP AS SINGLE FILE
				(
					loop = 1 
					TempPos = Selection.center --Orig POSITIONS
					MoveOffset = [0,0,0] - TempPos
					Move Selection  MoveOffset
						
					filename = JB_FilePath + (JB_BoxName as string) + "\\" + (JB_DrawerName as string) + "\\" + ( ( JB_FilesCount + loop + LoopOffset ) as string ) + ".max"
					
					while (doesfileexist filename) --FILE EXISTS, GOTTA DO SUMPTHIN"
						
							do    	
							(
								LoopOffset+=1
								filename = JB_FilePath + (JB_BoxName as string) + "\\" + (JB_DrawerName as string) + "\\" + ( ( JB_FilesCount + loop + LoopOffset ) as string ) + ".max"
							)
					
					saveNodes Selection filename
						
					Move Selection  -MoveOffset
					
				)
				
				--UPDATE DRAWER
				callDrawerPrepAndUpdateUI()	
				
			)
		)
		
		--RESTORE UNITS
		if roll_automat_JunkBoxTool.check_ForceInches.checked do
		(
			try ( units.systemType = usersystemunittype )catch()
		)

	)


	--------------------------------------------------------
	fn exportDrawerToOBJ JB_BoxName JB_DrawerName =
	(
		ExportCount = 0
		
		for LoadCounter = 1 to JB_FilesCount do
		(
			--------------
			try( mergeMAXFile CurrentFileName[LoadCounter]  #noRedraw #select  #useSceneMtlDups #autoRenameDups )
			catch
				(
					mergeMAXFile CurrentFileName[LoadCounter]  #noRedraw #select  #useSceneMtlDups
					for piggly in selection do
					(
						appendnum = "-" + (JunkCounterForRenameHack as string) + "-" + ((random 0 1000) as string)
						piggly.name = piggly.name + appendnum
						JunkCounterForRenameHack += 1
					)
				) --simplified for earlier versions of max
			--------------
			
			loop = 1 
			LoopOffset = 0
			
			filename = JB_FilePath + (JB_BoxName as string) + "\\" + (JB_DrawerName as string) + "\\" + ( (  loop + LoopOffset ) as string ) + ".obj"
					
			while (doesfileexist filename) --FILE EXISTS, GOTTA DO SUMPTHIN"
						
			do    	
			(
				LoopOffset+=1
				filename = JB_FilePath + (JB_BoxName as string) + "\\" + (JB_DrawerName as string) + "\\" + ( (  loop + LoopOffset ) as string ) + ".obj"
			)
				
			exportFile filename #noPrompt selectedOnly: true
			
			delete Selection
			ExportCount += 1
		)
		messagebox ( ( ExportCount as string ) + " Files exported to OBJ." )
		
	)
	--------------------------------------------------------	
	fn loadJB_Drawer JB_BoxName JB_DrawerName JBPrefs =
	(
		--unit scale checks
		if roll_automat_JunkBoxTool.check_ForceInches.checked do
		(
			usersystemunittype = units.systemType
			units.systemType = #inches
		)
		
		clearSelection()
		select $JunkBoxPoint_* --GET OLD POINTERS
		if selection.count > 0 do delete $	--I NEED THE  POINTER NAMES TO MATCH THE FILE NUMBERS
			
		ObjectCount = JB_FilesCount
		SpreadLength = 100
		findGridSizeAndSpacing  ObjectCount SpreadLength
		
		giveMeAGridOfPositions  GridSize GridSpacing --GET GRID FOR OBJECTS
		
		max create mode --Yahh!!
		
		PointParentCollection=#()

		for LoadCounter = 1 to JB_FilesCount do
		(
			ThisName = (uniquename "JunkBoxPoint_000")
			PointNumIndex[LoadCounter] = ThisName	--WHICH FILE CORRESPONDS TO WHICH POINTER
			append PointParentCollection ( point name:ThisName size:12 wirecolor:red showFrozenInGray:false)
			clearSelection()
			--------------
			try(mergeMAXFile CurrentFileName[LoadCounter]  #noRedraw #select  #useSceneMtlDups #autoRenameDups)
			catch
				(
					--down and dirty autorenaming function for versions of max that don't support the oh so much more simple autoRenameDups feature
					ObjectNamesInFile = getmaxfileobjectnames CurrentFileName[LoadCounter]
					for piggly in ObjectNamesInFile do
					(
						if  undefined != (SceneObjectWithDupName = getNodeByName piggly) do --if object name exists in scene already do rename functions
						(
							local tempnamearray=#()
							append tempnamearray piggly
							append tempnamearray (uniquename piggly)
							tempsceneobjname = uniquename (piggly + "_PolyG-temp-rename")
							append tempnamearray tempsceneobjname
							SceneObjectWithDupName.name = tempsceneobjname
							--format "tempsceneobjname: %\n" tempsceneobjname
							--format "SceneObjectWithDupName.name: %\n" SceneObjectWithDupName.name
							append RenamesForObjectsInFile tempnamearray
						)
					)
					--------------
					mergeMAXFile CurrentFileName[LoadCounter]  #noRedraw #select  #useSceneMtlDups
					TempSelect = selection
					--------------
					--format "\n\n\nRenamesForObjectsInFile: %\n" RenamesForObjectsInFile
					for winky = 1 to RenamesForObjectsInFile.count do
					(
						a = getNodeByName RenamesForObjectsInFile[winky][1]
						a.name = RenamesForObjectsInFile[winky][2]
						b = getNodeByName RenamesForObjectsInFile[winky][3]
						--format "b: %\n" b
						b.name = RenamesForObjectsInFile[winky][1]
					)
					select TempSelect
					RenamesForObjectsInFile=#() --CLEAR THIS ARRAY
				) 
			--------------
			getScaleFactorForObject GridSpacing selection --RETURNS JB_ScaleFactorForObject
			--------------
			ZOffsetForDrawer = if selection.min.z < 0 then abs selection.min.z else 0
			move selection [0,0,	ZOffsetForDrawer]
			--------------
			selection.parent = PointParentCollection[LoadCounter]
			PointParentCollection[LoadCounter].scale = [JB_ScaleFactorForObject,JB_ScaleFactorForObject,JB_ScaleFactorForObject]
			move PointParentCollection[LoadCounter] GridOfPositions[LoadCounter]
			
			PointParentCollection[LoadCounter].position.z = 0
			freeze PointParentCollection[LoadCounter]
			
			clearSelection()
			select $JunkBoxPoint_*
			
			max select child
			max zoomext sel
			if JBPrefs[1] == true do macros.run "Tools" "Isolate_Selection"
			
		)

		--RESTORE SYSTEM UNITS
		if roll_automat_JunkBoxTool.check_ForceInches.checked do
		(
			units.systemType = usersystemunittype
		)
		
		
	)
	

	--------------------------------------------------------
	fn keepJB_SelectedObjects selection =
	(

		
		max select parent
		
		local JB_SelectedPointers=#()
		local JB_SelectedKeepers=#()
		
		LinePos = 0.0 --Gonna lay out objects in a row
		for peep in selection do append JB_SelectedPointers peep
		--format "JB_SelectedPointers: %\n" JB_SelectedPointers
		
		max select child
		for peep in selection do append JB_SelectedKeepers peep
			
		ClearSelection()
		CountMax = JB_SelectedPointers.count
		--format "CountMax: %\n" CountMax
		
		for loop = 1 to CountMax do
		(
			JB_SelectedPointers[loop].scale = [1,1,1] --RESTORE SIZE
			--format "JB_SelectedPointers[loop].scale: %\n" JB_SelectedPointers[loop].scale

			select JB_SelectedPointers[loop]
			max select child
			LinePosOffset =  (selection.max.x - selection.min.x)/1.9  --ADDS 1/2 X of current object + 10% offset
			LinePos += LinePosOffset --ADD HALF OF OFFSET NOW
			
			JB_SelectedPointers[loop].position = [LinePos,0,0]	
			--format "JB_SelectedPointers[loop].position: %\n" JB_SelectedPointers[loop].position
			
			for peep in selection do peep.parent = undefined
			--format "JB_SelectedPointers[loop].parent: %\n" JB_SelectedPointers[loop].parent
			LinePos += LinePosOffset	-- AND HALF OF OFFSET LATER	
		)
		
		select $JunkBoxPoint_*
		max select child
		delete selection
		select $JunkBoxPoint_*
		delete selection
		
		for peep in JB_SelectedKeepers do selectmore peep
			--selectmore ( peep in JB_SelectedKeepers ) --try to get rid of do and selectmore combo
	)	


	------------------------------------------------------
	fn updateJBMessageText JB_FilesCount =
	(
		if 1 == JB_FilesCount then JB_DrawerCountMessage = "1 object in drawer"
			else JB_DrawerCountMessage = ( ( JB_FilesCount as string ) + " objects in drawer" )
	)

	--------------------------------------------------------
	fn removeFromDrawer JB_BoxName JB_DrawerName selection =
	(
		if 0 != selection.count do --this could be more specific
		(
			if querybox ("Permanently remove from drawer?") do
			(
				max select parent --GET POINT OBJS
				
				countend = selection.count
				innerloopend = PointNumIndex.count
				local DelArray=#()
				
				for count = 1 to countend do --SELECTION
				(
					for innerloop = 1 to innerloopend do --INDEX
					(
						if PointNumIndex[innerloop] == selection[count].name do deleteFile  CurrentFileName[innerloop]
						append DelArray selection[count]
					)
				)
				
				max select child
				delete selection
				select DelArray
				delete selection
				
				callDrawerPrepAndUpdateUI()	
			)
		)
	)

	--------------------------------------------------------
	fn doJBContainerAction JB_ActionMode JB_Action JB_UserText JB_BoxName JB_DrawerName =
	(
		case JB_Action of
		(
			--------------
			1: (
					--CREATE action
					if 1 == JB_ActionMode do --BOX
					(
						JB_GotoBoxName = JB_BoxName =  ( JB_UserText as string )
						filename = JB_FilePath + "\\" + JB_BoxName
						makeDir filename
						JB_UserText = "empty"
						
					)
					--else	--DRAWER
					
					JB_GotoDrawerName = JB_DrawerName = ( JB_UserText as string )
					filename = JB_FilePath + JB_BoxName + "\\" + JB_DrawerName
					
					
					makeDir filename
					
					--------------
					collectJB_BoxesAndDrawerNames()
					--------------
					JB_RESET = true --USE current box and drawer name to set interface
					callDrawerPrepAndUpdateUI()
				)
			
			2: (
					--RENAME action
					newname = ( JB_UserText as string )
				
					if 1 == JB_ActionMode then --BOX
					(
						filename = JB_FilePath + JB_BoxName --no backslash for rename command
						JB_GotoBoxName = newname
					)
					else	--DRAWER
					(
						if JB_DrawerName == "" or JB_DrawerName == JunkWarning do return()
						--format "JB_BoxName: %\n" JB_BoxName
						--format "JB_DrawerName: %\n" JB_DrawerName
						
							filename = JB_FilePath + JB_BoxName + "\\" + JB_DrawerName --NO BACKSLASH
							JB_GotoDrawerName = newname
						
					)
				
					
						
					hiddendoscommand ( "rename \"" + filename + "\" \"" + newname + "\"" )  startpath:"c:\\" exitCode:&exitcode --NEED QUOTES FOR DOS
	-- 				doscommandstring = ( "rename \"" + filename + "\" \"" + newname + "\"" )
	-- 				doscommand ( "rename \"" + filename + "\" \"" + newname + "\"" )  startpath:"c:\\" exitCode:&exitcode --NEED QUOTES FOR DOS
					
					if 0 != exitcode then 
					(
						messagebox ( "There was a problem.\nYou can, however, safely edit those directories manually.\n\n" + filename )
					)
					else --only call functions if the intended action took place
					(
						--------------
						collectJB_BoxesAndDrawerNames()
						--------------
						JB_RESET = true --USE current box and drawer name to set interface
						callDrawerPrepAndUpdateUI()
					)
				)
			--------------
			3: (
					--DELETE action
					if 1 == JB_ActionMode then --BOX
					(
						filename = JB_FilePath + JB_BoxName + "\\" 
						indexNum = (
											if 1 == JB_BoxNum then 2
												else JB_BoxNum - 1
										)
						JB_GotoBoxName = JB_BoxNames[indexNum]
					)
					else		--DRAWER
					(	
						if JB_DrawerName == "" or JB_DrawerName == JunkWarning do return()
						
						filename = JB_FilePath + (JB_BoxName as string) + "\\" + (JB_DrawerName as string) + "\\"
						indexNum = (
											if 1 == JB_DrawerNum then 2
												else JB_DrawerNum - 1
										)
						JB_GotoDrawerName = JB_DrawerNames[JB_BoxNum][indexNum]
					)
					
					hiddendoscommand ( "rmDir \"" + filename + "\"" ) startpath:"c:\\" exitCode:&exitcode --NEED QUOTES FOR DOS
						
					if 0 != exitcode then 
					(
						messagebox ( "Junk Box can't delete that directory; probably because there are files in it.\nYou can, however, safely edit those directories manually.\n\n" + filename )
					)
					else --only call functions if the intended action took place
					(
						JB_RESET = true 
						--------------
						collectJB_BoxesAndDrawerNames()
						--------------			
						callDrawerPrepAndUpdateUI()
					)	
					
				)
		)
		
		
		
	)

	--------------------------------------------------------
	fn doIsolateDrawer =
	(
		select $JunkBoxPoint_*
		max select child
		selectmore $JunkBoxPoint_*
		
		macros.run "Tools" "Isolate_Selection"
		
		deselect $JunkBoxPoint_*	
		
	)
	--------------------------------------------------------
	fn makeSomethingStupid =
	(
		max create mode
					
		GridSize=#(3,3,4)
		GridSpacing = 45.0
		giveMeAGridOfPositions  GridSize GridSpacing
		clearSelection()
		for bleep = 1 to GridOfPositions.count do 
		(
			selectmore ( sphere Position: (GridOfPositions[bleep]) )
		)
		redrawViews()
	)
	
	--INFO COLLECTED BEFORE UI IS DRAWN
	--/////////////////////////////////////////////
	--------------------------------------------------------
	getapref = ( getINISetting CurrentINI "Junk Box Prefs" "JB_FilePath" ) as string
	if getapref != "" do JB_FilePath = getapref
	format "JB_FilePath: %\n" JB_FilePath
	collectJB_BoxesAndDrawerNames() --LOAD UP DATA BEFORE INTERFACE GETS BUILT OR ELSE!!!
	callDrawerPrepAndUpdateUI()
	
	
	if true != automat_OpenScriptAsRollout then
	(
		
		try (closeRolloutfloater automat_JunkBoxTool ) catch ()	
		automat_JunkBoxTool = newRolloutFloater "Junk Box ff" 170 665 RolloutPosition.x RolloutPosition.y
		addRollout roll_automat_JunkBoxTool automat_JunkBoxTool
		automat_JunkBoxTool.size.y = ( roll_automat_JunkBoxTool.height + 30 )
		
	)
	else()


)
	