
--	SplineTools.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.0
--	CREATED:	02-19-2011 --3dsmax 2011
--	MODIFIED:	02-19-2011 --3dsmax 2011

(
	global automat_SplineTools
	
	local SplinePasteEnableState=true
	local ObjArray
	local ObjArrayThicks=#()
	
	--Rollout Position
	--------------------------------------------------------
	local CurrentINI = GetDir #plugcfg + "\\automat_SplineTool.ini"

	local RolloutPosition= [200,200]
	
	getapref = execute ( getINISetting CurrentINI "Spline Tool" "RolloutPosition" )
		if getapref != OK do RolloutPosition = getapref
	--------------------------------------------------------
	
	--------------
	if automat_StoredSplineParameters == undefined do
	(
		global automat_StoredSplineParameters=#() 
	)
	try automat_StoredSplineParameters.count==0 catch(  SplinePasteEnableState=false)  --TURN OFF PASTE BUTTON
	
	--------------
	function storeSplineParameters Selection =
	(
			ObjArray = for piggy in Selection where classof (piggy) == line or classof (piggy)== SplineShape collect piggy --Get LINES only
			CurrentObject = selection[1]
			TempPropList = getpropnames CurrentObject --JUST GET FIRST OBJECT
					
			automat_StoredSplineParameters=#() 
		
			for wiggly = 1 to TempPropList.count do
			(
				TempArray=#()
				TempArray[1] = TempPropList[wiggly] --GET PROP NAME
				append TempArray ( getProperty CurrentObject TempPropList[wiggly] ) --GET PROP SETTING
				append automat_StoredSplineParameters TempArray --ADD TO ARRAY
			)
	)
	
	--------------
	function applySplineParameters Selection =
	(
		ObjArray = for piggy in Selection where superclassof (piggy) == shape collect piggy --Get shapes
		if ObjArray != undefined and automat_StoredSplineParameters != undefined then
		(
				undo on
			(
				for piggly in ObjArray do
				(
					for wiggly = 1 to automat_StoredSplineParameters.count do
					(
						setProperty piggly automat_StoredSplineParameters[wiggly][1] automat_StoredSplineParameters[wiggly][2]
					)
				)
			)
		)
		else messagebox "First select a spline and use the copy button. Then you can apply those settings to any selection of splines and/or shapes."
	)
	
	
	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout roll_automat_SplineTools "SplineTools"
		(
			group "Copy/Paste Spline Settings:"
			(
				button but_CopySplineSettings "Copy" tooltip: "Copy settings from selected spline." across:2 
				button but_PasteSplineSettings "Paste" tooltip: "Paste copied spline settings to a selection of shapes or splines." enabled:SplinePasteEnableState
			)
			
			slider Spline_Thickness "Adjust Thickness:" range:[0.25,1.75,1]	
			
			on roll_automat_SplineTools moved ScreenPos do
			(
				setapref =  setINISetting CurrentINI "Spline Tool" "RolloutPosition" (ScreenPos as string )
			)
			
			
			
			--Rollout Collapsifier
			--------------------------------------------------------
			on roll_automat_SplineTools rolledUp state do
			(
				if false == state then --minimize
				(
					try(automat_SplineTools.size.y = 24)catch()
				)
				else
				(
					try( automat_SplineTools.size.y = ( roll_automat_SplineTools.height + 30 ) )catch()
				)	
			)
				
			--Buttons
			--/////////////////////////////////////////////
			--------------------------------------------------------
			on but_CopySplineSettings pressed do
			(
				storeSplineParameters Selection
				but_PasteSplineSettings.enabled = SplinePasteEnableState=true
			)
			
			--------------
			on but_PasteSplineSettings pressed do
			(
				applySplineParameters Selection
			)
			
			--------------
			on Spline_Thickness buttondown do
			(
				objArray = for piggy in Selection where ( (try( piggy.thickness )catch(0)) >0 ) collect piggy --GET OBJS with thickness
				
				SplineMinVal=0.25
				SplineMaxVal=3
				
				ObjArrayThicks=#()
				
				for spunky = 1 to ObjArray.count do
				(
					ObjArrayThicks[spunky]=ObjArray[spunky].thickness
					
				)
			)
			
			--------------
			on Spline_Thickness changed SlideVal do
			(
				undo off
				(
					for wiggly = 1 to ObjArray.count do
					(
						ObjArray[wiggly].thickness = ObjArrayThicks[wiggly] * SlideVal	
					)
				)
			)
			
			--------------
			on Spline_Thickness buttonup do
			(
				undo off
				(
					for wiggly = 1 to ObjArray.count do
						(
							ObjArray[wiggly].thickness = ObjArrayThicks[wiggly] --RESTORE TO ORIG
						)
				)
				
				undo on
				(
					for wiggly = 1 to ObjArray.count do
						(
							ObjArray[wiggly].thickness = ObjArrayThicks[wiggly] * Spline_Thickness.value
						)
				)
				
				Spline_Thickness.value=1
			)
			
		)
	
	
	if true != automat_OpenScriptAsRollout then
	(
		try (closeRolloutfloater automat_SplineTools ) catch ()
		automat_SplineTools = newRolloutFloater "SplineTools" 170 102 RolloutPosition.x RolloutPosition.y
		addRollout roll_automat_SplineTools automat_SplineTools
		automat_SplineTools.size.y = ( roll_automat_SplineTools.height + 30 )
	)
	else()
)