
--	SplodeTools.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.0
--	CREATED:	02-19-2011 --3dsmax 2011
--	MODIFIED:	02-19-2011 --3dsmax 2011
(
	global automat_SplodeTool
	local ObjArray
	
	--Rollout Position
	--------------------------------------------------------
	local CurrentINI = GetDir #plugcfg + "\\automat_SplodeTool.ini"

	local RolloutPosition= [200,200]
	
	getapref = execute ( getINISetting CurrentINI "Splode" "RolloutPosition" )
			if getapref != OK do RolloutPosition = getapref
	--------------------------------------------------------
	
	local Array_SplodeX=#()
	local Array_SplodeY=#()
	local Array_SplodeZ=#()
	
	local Array_CurrentX=#()
	local Array_CurrentY=#()
	local Array_CurrentZ=#()
	
	local ObjArrayX=#()
	local ObjArrayY=#()
	local ObjArrayZ=#()
	
	--------------
	local SplodeStart=#()
	local SplodeDistance=#()
	local ObjArray_Current=#()
	local ObjArray_Splode=#()
	local SplodeCenter
	local SplodeCount
	if PolyGSavedSplodes==undefined do global PolyGSavedSplodes=#()
	local slide_Sploder
	local SplodeX, SplodeY, SplodeZ
	local rad_SplodeMode
	
	local StoreSplodePositions
	local Spin_SplodeMultiplier
	local SplodeChecks=#() --STORE CHECK states in array
	local ObjArrayFoundSavedSplodeNames=#()
	local ObjArrayFoundSavedSplodes=#()
	--------------
	
	
	--------------------------------------------------------
	function sortObjectsForX v1 v2 =
	(
		local CompareTestValue = (v1.position.x)-(v2.position.x)
		case of
		(
			(CompareTestValue < 0.): -1
			(CompareTestValue > 0.): 1
			default: 0
		)
	)
	--------------------------------------------------------
	function sortObjectsForY v1 v2=
	(
		local CompareTestValue = (v1.position.y)-(v2.position.y)
		case of
		(
			(CompareTestValue < 0.): -1
			(CompareTestValue > 0.): 1
			default: 0
		)
	)
	--------------------------------------------------------
	function sortObjectsForZ v1 v2=
	(
		local CompareTestValue = (v1.position.z)-(v2.position.z)
		case of
		(
			(CompareTestValue < 0.): -1
			(CompareTestValue > 0.): 1
			default: 0
		)
	)
	
	
	--------------------------------------------------------
	function sortObjectsByName v1 v2 = 
	(
		local CompareTestValue = (v1.position.x)-(v2.position.x)
		case of
		(
			(CompareTestValue < 0.): -1
			(CompareTestValue > 0.): 1
			default: 0
		)
	)
		
	
		
	--------------------------------------------------------
	function getSplodeNodes selection=
	(
		objArray = for piggy in selection where piggy.pivot != undefined  collect piggy --simple
	)
	
	--------------------------------------------------------
	rollout roll_automat_SplodeTool "Splode Selected Objects"
	(
		checkbox splodeX "X" checked:true across:3
		checkbox splodeY "Y" offset:[5,0] checked:false 
		checkbox splodeZ "Z" offset:[10,0] checked:false
		
		group "Splode Mode:"
		(
			Radiobuttons rad_SplodeMode labels:#("Align" , "Distribute","Stored") default:2 columns:1 offset:[5,0]
			slider slide_Sploder tooltip:"" range:[0,1,0] offset:[6,-5]--set this to ten times the bounding box size
			button StoreSplodePositions "Store Current Positions"
		)
		spinner Spin_SplodeMultiplier "Expand Power:" range:[0,10,2] type:#integer 
		checkbox Check_SplodeScaleMode "Uniform Expand Mode" offset:[5,3] checked:false  
		
	
		
		on roll_automat_SplodeTool moved ScreenPos do
		(
			setapref =  setINISetting CurrentINI "Splode" "RolloutPosition" (ScreenPos as string )
		)
		
		--Rollout Collapsifier
		--------------------------------------------------------
		on roll_automat_SplodeTool rolledUp state do
		(
			if false == state then --minimize
			(
				try(automat_SplodeTool.size.y = 24)catch()
			)
			else
			(
				try( automat_SplodeTool.size.y = ( roll_automat_SplodeTool.height + 30 ) )catch()
			)	
		)
		
		--------------------------------------------------------
		on slide_Sploder buttondown do --PREP FOR SPLODE
		(
			getSplodeNodes selection --SPLODE GET OBJECTS
			
			SplodeCenter=selection.center
			SplodeCount=Selection.count --Object count
			SplodeAmount=Spin_SplodeMultiplier.value --easier to give it a cute name
			
			SplodeChecks[1]=splodeX.checked --X
			SplodeChecks[2]=splodeY.checked --Y
			SplodeChecks[3]=splodeZ.checked --Z
			SplodeChecks[4] = ( ( if true == SplodeChecks[1] then 1 else 0 ) + ( if true == SplodeChecks[2] then 2 else 0 ) + ( if true == SplodeChecks[3] then 4 else 0 ) )
			
			--EXIT FOR STORED MODE
			if rad_SplodeMode.state !=3 then
			(
				--CALCULATE SPLODE DISTANCE using spinner and radio button and guessing
				SplodeDistance=#() --clear this out
				SplodeDistance[1] = (Selection.max.x-Selection.min.x) --X extents
				SplodeDistance[2]=(Selection.max.y-Selection.min.y) --Y extentes
				SplodeDistance[3]=(Selection.max.z-Selection.min.z) --Z extents
				SplodeDistance[4]=( ( SplodeDistance[1]+SplodeDistance[2]+SplodeDistance[3] ) /3 ) --average of X,Y,Z
				
				--AVERAGE or PROPORTIONAL?
				if Check_SplodeScaleMode.checked==true then \
					SplodeDistance[1]=SplodeDistance[2]=SplodeDistance[3]=(SplodeDistance[4]*SplodeAmount) --ALL SplodeAmount * average
				
				else for piggy=1 to 3 do SplodeDistance[piggy]*=SplodeAmount --X,Y,Z times SplodeAmount
				
				--SORT OBJECTS
				--------------------------------------------------------
				if 4 == SplodeChecks[4] then qsort objArray sortObjectsForZ
					else if SplodeChecks[4] >= 2 then qsort objArray sortObjectsForY
						else qsort objArray sortObjectsForX
				
				--------------------------------------------------------
				--SPLODE CENTER
				for piggy= 1 to 3 do --X,Y,Z
				(
					SplodeCenter[piggy] = if (mod ObjArray.count 2 ==1 ) then ObjArray[( ObjArray.count/2 +1) ].position[piggy] --USE CENTER OBJECT if count is odd
								else ( ( ObjArray[1].position[piggy] + ObjArray[ObjArray.count].position[piggy] ) / 2) --OR USE CENTER 
				)
				
				--SPLODE ARRAYS INITIAL SETUP
				for sparky = 1 to ObjArray.count do
				(
					ObjArray_Current[sparky]=ObjArray[sparky].position --COPY POINT3
					ObjArray_Splode[sparky]=ObjArray[sparky].position --COPY POINT3
				)
			
			
				--CALCULATE ALL SPLODE POSITIONS
				for loopy = 1 to 3 do -- LOOPY X,Y,Z
				(
					if SplodeChecks[loopy]==true do --CALCULATE VALUE OF X,Y,Z
					(
						SplodeStart[loopy] = SplodeCenter[loopy]-(SplodeDistance[loopy]/2) --OK
						SplodeIncrement=SplodeDistance[loopy]/(SplodeCount-1) --OK
						
						for i = 1 to (SplodeCount) do --THRU ALL SPLODE OBJECTS
							(
								if rad_SplodeMode.state ==1 then  ObjArray_Splode[i][loopy] = SplodeCenter[loopy] \ --IF CONTRACT USE CENTER
									else  ObjArray_Splode[i][loopy]  = (SplodeStart[loopy] + SplodeIncrement*(i-1)  ) --OR CALCULATE
								
							)
					)
					 --OR USE CURRENT VALUE
				) 
			)
			else if PolyGSavedSplodes.count>0 do
			(
					--GET POSITIONS FOR SAVED SPLODES
				(
					ObjArray_Current=#() --RESET
					ObjArrayFoundSavedSplodes=#() --RESET ARRAY OF OBJECTS
					ObjArrayFoundSavedSplodeNames=#() --RESET ARRAY OF NAMES
					
					for i in ObjArray do --SEARCH TRHU OBJECTS
					(
						--SEARCH SAVED SPLODENAMES
						for j = 1 to PolyGSavedSplodes.count do 
						(
							--IF NAME FOUND IN SAVE ARRAY THEN ADD NAME
							if ( ( matchPattern PolyGSavedSplodes [j][1]  pattern: i.name ) == true) do
							(
								append  ObjArrayFoundSavedSplodeNames PolyGSavedSplodes [j] --ADD NAME
							)								
						)
					)
					
					--added to prevent error when setting up undo
					ObjArray=#()
					for eachitem in ObjArrayFoundSavedSplodeNames do append eachitem ObjArray
					
					for wiggly = 1 to ObjArrayFoundSavedSplodeNames.count do
					(
						local foundone=#() --CLEAR FOR EACH LOOP
						foundone[1]=getNodeByName ObjArrayFoundSavedSplodeNames[wiggly][1] --GETS ACTUAL OBJECT
						foundone[2]=ObjArrayFoundSavedSplodeNames[wiggly][2] --GETS POINT3 POSITION
						append ObjArrayFoundSavedSplodes foundone	--ADDS NODE and STORED POS. TO ARRAY
					)
					
					
					for wiggly in ObjArrayFoundSavedSplodes do append ObjArray_Current wiggly[1].position --SAVE CURRENT POS
				)
			)
			
		)	
	
		--------------------------------------------------------
		on slide_Sploder buttonup do
		(
			--STORE CHANGED POSITIONS
			local Obj_Array_Changed=#()
			if ObjArray.count > 0 do
			(
					undo off
				(
					for peep in ObjArray do append  Obj_Array_Changed peep.pos  --STORE NEW POS
					
					for peep = 1 to ObjArray.count do ObjArray[peep].pos = ObjArray_Current[peep] --STARTING POSITIONS
				)
				undo on
				(
					for peep = 1 to ObjArray.count do ObjArray[peep].pos=Obj_Array_Changed[peep] --PUT BACK CHANGED POS w/ undo
				)
			)	
			
			slide_Sploder.value=0.0
			if ObjArray.count<2 and rad_SplodeMode.state !=3 do messagebox "Please select at least two objects.\n\nSplode aligns and distributes multiple objects. "
			redrawViews()
		)
		
		--------------------------------------------------------
		on slide_Sploder changed i do --SPLODE SLIDER MOVED
		(
			undo off --DONT save a million small changes
			(
				if ObjArray.count>1 and rad_SplodeMode.state !=3 then --HAVE multiple objects
				(
						for objnum = 1 to ObjArray.count do --THRU OBJECTS
						(
							
							--NEED TO COMBINE VALUES INTO A SINGLE POINT 3
							GotoPosition=[0,0,0] --EMPTY POINT3
							
							for xyzloop = 1 to 3 do -- X,Y,Z -LOOP
							(
								if SplodeChecks[xyzloop]==true then 
								(
									GotoPosition[xyzloop]=ObjArray_Splode[objnum][xyzloop] --USE SPLODE NUMBER
								)
								else GotoPosition[xyzloop]=ObjArray_Current[objnum][xyzloop] --OR USE CURRENT NUMBER
							)
							
							--UPDATES WITH CHANGES TO SLIDER
							ObjArray[objnum].position=((ObjArray_Current[objnum]*(1-slide_Sploder.value)) + (GotoPosition*slide_Sploder.value))  --MIX current and splode
						)	
				)
				
				else if rad_SplodeMode.state ==3 do --RESTORE MODE
				(
					for tweedle = 1 to 	ObjArrayFoundSavedSplodes.count do
					(
					ObjArrayFoundSavedSplodes[tweedle][1].position=( ( ObjArray_Current[tweedle]*(1-slide_Sploder.value))+ ObjArrayFoundSavedSplodes[tweedle][2]*slide_Sploder.value  )   --MIX current and splode
					)
				)
				
			) --END UNDO
			
		)
		
		--------------------------------------------------------
		on StoreSplodePositions pressed do --save splode positions
		(
			PolyGSavedSplodes=#() --EMPTY THIS
			getSplodeNodes selection --SPLODE GET OBJECTS
			
			for i = 1 to ObjArray.count do
				(
					local TempObjInfo=#()
					TempObjInfo[1]=ObjArray[i].name
					TempObjInfo[2]=ObjArray[i].position
					PolyGSavedSplodes[i] =  TempObjInfo
					--this should save name and position for each object saved
				)
		)
		
	)


	
	
	if true != automat_OpenScriptAsRollout then
	(
		try (closeRolloutfloater automat_SplodeTool ) catch ()
		automat_SplodeTool = newRolloutFloater "Splode" 170 102 RolloutPosition.x RolloutPosition.y
		addRollout roll_automat_SplodeTool automat_SplodeTool
		automat_SplodeTool.size.y = ( roll_automat_SplodeTool.height + 30 )
	)
	else()
	
	
)
