
--	Eolith.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.0
--	CREATED:	02-19-2011 --3dsmax 2011

--	01-27-12	Moved to nubbin. Added pref to save/load rollout position

(
	global automat_SubDivCalculator
	--------------------------------------------------------
	if true != BurkeLibLoaded do include "$userScripts/BurkeStudios/lib/BurkeLib.ms"
		
	--
	local CurrentINI = GetDir #plugcfg + "\\automat_SubDivCalculator.ini" 
	--
	local RolloutPosition= [200,200]
	
	getapref = execute ( getINISetting CurrentINI "Subdivison Calculator" "RolloutPosition" )
			if getapref != OK do RolloutPosition = getapref
	
	--
		
	local SDivNum = 1
	local SDivUserData = 1
	local SDivNumArray=#()
	local SDivTextArray=#()

	local SubDFaces = 1
	local SubDObjects = 0
	local SubDMessage = ""
	local DoSDivMessage = false
	local clearSDivUI
	
	--Function Names
	--------------------------------------------------------
	local calculateSDivs
	local getFaceCountFromSelection
	
	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout roll_automat_SubDivCalculator "Subdivison Calculator"
	(
		button but_estimateSubD "Estimate from Selection" tooltip:"Click button to estimate based on current selection of E-poly objects.\n\nAlternately, use the fields below to enter values.\n\n*These calculations assume all polygons are quads. Triangles will produce fewer total polygons."
		edittext text_Sdiv0   text:"" readonly:true width:140 offset:[-6,0]
		
		edittext text_Sdiv1 "Sdiv1:"  text:"" width:130
		edittext text_Sdiv2 "Sdiv2:"  text:"" width:130
		edittext text_Sdiv3 "Sdiv3:"  text:"" width:130
		edittext text_Sdiv4 "Sdiv4:"  width:130
		edittext text_Sdiv5 "Sdiv5:"  width:130
		edittext text_Sdiv6 "Sdiv6:"  bold:true width:130
		edittext text_Sdiv7 "Sdiv7:"  bold: true width:130
		edittext text_Sdiv8 "Sdiv8:"  width:130
		edittext text_Sdiv9	"Sdiv9:"  width:130
		
		--------------
		
		on roll_automat_SubDivCalculator moved ScreenPos do
		(
			setapref =  setINISetting CurrentINI "Subdivison Calculator" "RolloutPosition" (ScreenPos as string )
		)
		
		
		
		--Rollout Collapsifier
		--------------------------------------------------------
		on roll_automat_SubDivCalculator rolledUp state do
		(
			if false == state then --minimize
			(
				try(automat_SubDivCalculator.size.y = 24)catch()
			)
			else
			(
				try( automat_SubDivCalculator.size.y = ( roll_automat_SubDivCalculator.height + 30 ) )catch()
			)	
		)
		--
		
		
		function updateSDviUI =
		(
			text_Sdiv0.text = SubDMessage
			text_Sdiv1.text = SDivTextArray[1]
			text_Sdiv2.text = SDivTextArray[2]
			text_Sdiv3.text = SDivTextArray[3]
			text_Sdiv4.text = SDivTextArray[4]
			text_Sdiv5.text = SDivTextArray[5]
			text_Sdiv6.text = SDivTextArray[6]
			text_Sdiv7.text = SDivTextArray[7]
			text_Sdiv8.text = SDivTextArray[8]
			text_Sdiv9.text = SDivTextArray[9]
		)
		
		--------------
		function clearSDivUI =
		(
			text_Sdiv0.text = SubDMessage
			text_Sdiv1.text = ""
			text_Sdiv2.text = ""
			text_Sdiv3.text = ""
			text_Sdiv4.text = ""
			text_Sdiv5.text = ""
			text_Sdiv6.text = ""
			text_Sdiv7.text = ""
			text_Sdiv8.text = ""
			text_Sdiv9.text = ""
		)
		
		on but_estimateSubD pressed do
			(
				
				facecount = ( getFaceCountFromSelection selection )
				if facecount > 0 then
				(
					DoSDivMessage = true
					calculateSDivs ( facecount as string) 1
					updateSDviUI()
					DoSDivMessage = false
				)
				else
				(
					clearSDivUI()
				)
			)
			
		
		on text_Sdiv1 entered SDivUserData do
		(
			calculateSDivs SDivUserData 1
			updateSDviUI()
		)
		on text_Sdiv2 entered SDivUserData do
		(
			calculateSDivs SDivUserData 2
			updateSDviUI()
		)
		on text_Sdiv3 entered SDivUserData do
		(
			calculateSDivs SDivUserData 3
			updateSDviUI()
		)
		on text_Sdiv4 entered SDivUserData do
		(
			calculateSDivs SDivUserData 4
			updateSDviUI()
		)
		on text_Sdiv5 entered SDivUserData do
		(
			calculateSDivs SDivUserData 5
			updateSDviUI()
		)
		on text_Sdiv6 entered SDivUserData do
		(
			calculateSDivs SDivUserData 6
			updateSDviUI()
		)
		on text_Sdiv7 entered SDivUserData do
		(
			calculateSDivs SDivUserData 7
			updateSDviUI()
		)
		on text_Sdiv8 entered SDivUserData do
		(
			calculateSDivs SDivUserData 8
			updateSDviUI()
		)
		on text_Sdiv9 entered SDivUserData do
		(
			calculateSDivs SDivUserData 9
			updateSDviUI()
		)
		
	)
	
	--FUNCTIONS
	--/////////////////////////////////////////////
	--------------------------------------------------------
	function calculateSDivs SDivUserData SDivNum =
	(
		SDivNumArray=#() --clear this
		SDivTextArray=#() --clear
		if false == DoSDivMessage do SubDMessage = ""
		
		--strip commas
		SDivUserData = substituteString SDivUserData "," ""

		--go back to 1
		local checkuserdata = SDivUserData as float
		if checkuserdata != undefined then
		(
			for loop = 1 to ( SDivNum - 1 ) do
			(
				checkuserdata /= 4
			)
	-- 		format "checkuserdata: %\n" checkuserdata
			
			if checkuserdata < 1 do checkuserdata = 1 --can't be any lower than one
			checkuserdata = checkuserdata as integer -- this should make things simple
			
			--see if adding 1 to start num gets closer to desired number
			testvalue1 = checkuserdata * ( pow 4 ( SDivNum-1 ) )
			testvalue2 = ( checkuserdata +1 ) * (  pow 4 ( SDivNum-1 ) )
	-- 		format "testvalue1: %\n" testvalue1
	-- 		format "testvalue2: %\n" testvalue2
			local userwanted = SDivUserData as integer
			if ( testvalue2 - userwanted ) < ( userwanted - testvalue1) do checkuserdata += 1
			
			for loop = 1 to 9 do
			(
				SDivNumArray[loop] = checkuserdata
				checkuserdata *= 4
			)
			
			for loop = 1 to 9 do
			(
				SDivTextArray[loop] =  ( gimmeCommas  SDivNumArray[loop]  )
			)
			
	-- 		print ( SDivUserData as integer )
		)
		else
		(
			messagebox "You can enter numbers in any of the boxes . . . but only numbers only please."
			calculateSDivs ( 0 as string ) 1
			roll_automat_SubDivCalculator.updateSDviUI()
		)
	)

	--------------------------------------------------------
	function getFaceCountFromSelection selection =
	(
		--return facecount
		-- set interface variables for object name or object count
		
		SubDFaces = 0
		
		ObjArray = for piggy in selection where classof(piggy.baseobject ) == Editable_Poly collect piggy
		MisObjArray = for piggy in selection where classof(piggy.baseobject ) != Editable_Poly collect piggy
		
		for EachObj in MisObjArray do deselect EachObj
		
		if ( SubDObjects = ObjArray.count ) > 0 then
		(
			for wiggly in ObjArray do 
			(
				SubDFaces += wiggly.numFaces
			)
			--format "SubDObjects: %\n" SubDObjects
			
			--DO MESSAGE
			
			textstring1 = if 0 == ObjArray.count then ""
			else if 1 == ObjArray.count then ObjArray[1].name
				else ObjArray.count as string +  " Objects"
			
			textstring2 = if 0 == MisObjArray.count then ""
				else ", " + MisObjArray.count as string +  " Skipped."
			SubDMessage = textstring1 + textstring2
			
			SubDFaces	--return
		)
		else if MisObjArray.count > 0 do SubDMessage = "All objects skipped."
			
		SubDFaces --return 0
	)
	
	if true != automat_OpenScriptAsRollout do
	(
		try (closeRolloutfloater automat_SubDivCalculator ) catch ()
		automat_SubDivCalculator = newRolloutFloater "sDiv Calculator" 170 200 RolloutPosition.x RolloutPosition.y
		addRollout roll_automat_SubDivCalculator automat_SubDivCalculator
		automat_SubDivCalculator.size.y = ( roll_automat_SubDivCalculator.height + 30 )
	)
)
