
--	ImageBAR.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.3
--	CREATED:	03-21-2011 --3dsmax 2011

--	04-13-14	Added Max X and Max Y functionality, added limit on number of images, added ability to launch explorer window to manage files
--	1-26-12 Added save/restore of current directory
--	1-7-12	Image displayed with Control key no longer disappears. Only one displayed image can remain persistant at the moment.
--	5-6-11	Added ability to cycle past start end end image bars.
--  8-8-12 Added version check to make gamma work with max 2013. feckin' gamma
--	8-19-12		Kludged the gamma to get thumbnails to display almost correctly in max 2013, removed low-quality icons because they used a different path with a different gamma result. What a pain!
--	8-20-12		restored the hi-quality icon checkbox, streamlined icon rendering (moved it into it's own function so that icon updates can happen properly without rendering icons twice.

(
	global automat_ImageBAR
	global Roll_automat_ImageBAR
	global KeepImageAroundAwhile 
	
	
	
	local CurrentINI = GetDir #plugcfg + "\\automat_ImageBAR.ini"
	local currentMaxVersion = (maxVersion())[1]/1000.0
	--
	if true != BurkeLibLoaded do include "$userScripts/BurkeStudios/lib/BurkeLib.ms"

	
	--function names
	local openImageToolbar
	local ImageBarDirectories =#()
	local ImageBarDirCount = 0
	local ImageBarNames=#()
	local prepThenLaunchToolbar
	
	--local IBCurrentDir --this will be the one selected
	local CurrIcons=#()
	local IconCount = 0
	local CurrBigs=#()
	local getGammaExtensionSring
	local getImageBarDirectories
	local getCurrentImages
	local getIBprefs
	local buildNewIcons
	local updateIconProgBar
	local LocationName = ""
	local updateTheIconPreviewImage
	--local HighQualityIcons = false
	
	
	--variables
	local GammaExtensionSring = "_22"
	local MyMouseDown = false
	local ChangeImage = false
	local RejectedImageCount = 0 --store the number of images excluded from bar
	--getGammaExtensionSring()
	local TempMap
	local BuildIconProgress = 0
	local MoreExt = #("jpeg","png","gif")
	
	
	local ImageBar_FilePath = (  (getdir #maxroot)+"\\maps\\ImageBar\\" ) --default location
	local ToolbarIconImage --= OpenBitMap ( ImageBar_FilePath + "\\00_Test\\Icons" + "" + ".png" ) --DEFAULT
	
	--------------
	
	--------------
	
	--local ShowBig

	global automat_ImageToolbar
	global automat_ImageToolbarBig
	global automat_IT_PrettyPicture
	local automat_ImageToolBarPos
	global ToolBarIsOpen = false
	
		
	--INI settings
	--------------------------------------------------------

	struct struct_ImageToolbar
	(
		pickdir,
		highqualityicons = false,
		toolbarpos = undefined,
		maxX = 800,
		maxY = 900,
		imagelimit = 23
	)
	
	local BAR_prefs = struct_ImageToolbar()
	--------------------------------------------------------

	
	--function names
	--------------------------------------------------------

	--------------------------------------------------------

	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout Roll_automat_ImageBAR "Automat Imagebar"
	(
		group "Image Toolbar:"
		(
			button but_LaunchToolbar "Launch" height:20 width:50 \
			tooltip:"Click to open the current Imagebar. Clicking in the ImageBar window will expand the bar and show your currently selected image full-size.\n
SHORTCUTS FOR IMAGEBAR WINDOW\n
Right-Click\nin Imagebar window to navigate to the next directory.\n
Ctrl + Right-Click\nfor previous directory.\n
Press Ctrl key\nas you exit the bar to retain a window containing the current full-size image.
Ctrl + Shift constrains window to max x and y dimensions.\n
Press Ctrl + Alt key\nas you exit the bar to delete the current image from disk.\n
You can close this rollout and operate Imagebar just using the above methods."
			
			dropDownList drop_PickImageBar "Choose a directory:"  items:#("-") offset:[0,-2]
			
			Checkbox check_HighQualityIcons "High-Quality Icons" checked:false \
			tooltip:"This can be slow but only needs to be done when images in directory are changed."
			
			Spinner spin_MaxX "max X:" across: 2 offset:[11,0] type: #integer range: [ 64, 4096, 800 ] fieldWidth: 34 \
			tooltip:"Maximum Dimension in X of displayed images. The objective is to keep very large images from bleeding offscreen."
			Spinner spin_MaxY "Y:" offset:[5,0] type: #integer range: [ 64, 4096, 900 ] fieldWidth: 34 \
			tooltip:"Maximum Dimension in Y of displayed images. The objective is to keep very large images from bleeding offscreen."
			
			Spinner spin_ImageLimit "image limit per bar:" offset:[4,0] type: #integer range: [ 1, 100, 23 ] fieldWidth: 34 \
			tooltip:"Maximum number of images per imagebar. Remaining images in directory will not be displayed."
			
			
			button but_ImageLocation "Location..." width:65 across:2 offset:[-3,0] \
			tooltip: "Left-Click: Choose a new location to look for Imagebar images.\n
Ctrl + Left-Click to open an explorer window at current Imagebar location.\n
Right-Click: Restore default location"
			
			button but_RebuildIcons "Rebuild Icons" width:75 offset:[3,0] tooltip:"Rebuild icons for current directory."
			edittext text_Location text:"" readonly:true enabled:true color:gray \
				width:145 offset:[-9,0]

		)
		
		--INI related
		--------------------------------------------------------
		on Roll_automat_ImageBAR open do
		(
			
			--------------
			getapref =  execute ( getINISetting CurrentINI "Toolbar Settings" "Position" )
			if getapref != OK do BAR_prefs.toolbarpos = getapref
			getapref =  execute ( getINISetting CurrentINI "Toolbar Settings" "High-Quality Icons" )
			if getapref != OK do BAR_prefs.highqualityicons = check_HighQualityIcons.checked = getapref
			--
			getapref = ( getINISetting CurrentINI "Toolbar Settings" "Directory Location" ) as string
			if getapref != "" do ImageBar_FilePath = getapref
			--
			getapref =  execute ( getINISetting CurrentINI "Toolbar Settings" "Max X" )
			if getapref != OK do BAR_prefs.maxX = spin_MaxX.value = getapref
			--
			getapref =  execute ( getINISetting CurrentINI "Toolbar Settings" "Max Y" )
			if getapref != OK do BAR_prefs.maxY = spin_MaxY.value = getapref
			--
			getapref =  execute ( getINISetting CurrentINI "Toolbar Settings" "Image Limit" )
			if getapref != OK do BAR_prefs.ImageLimit = spin_ImageLimit.value = getapref
			--
			getIBprefs()
			getCurrentImages()
			
			--update UI
			getImageBarDirectories()
			drop_PickImageBar.items = ImageBarNames
			text_Location.text = LocationName
			
			getapref = execute ( getINISetting CurrentINI "Toolbar Settings" "Current Directory Number" )
			if getapref != OK and getapref <= ImageBarDirCount do drop_PickImageBar.selection = getapref
			
			
			
		)
		
		--BUTTONS
		--/////////////////////////////////////////////
		--------------------------------------------------------
		--------------------------------------------------------
			
		on roll_automat_ImageBAR close do
		(
			--saving this only on close, that's the simplest way
			setapref = setINISetting CurrentINI "Toolbar Settings" "Current Directory Number" ( drop_PickImageBar.selection as string  )
		)
		
		on but_LaunchToolbar pressed do
		(
			prepThenLaunchToolbar()
		)
		
		on drop_PickImageBar selected item do
		(
			
			
			if ToolBarIsOpen do
			(
				getIBprefs()
				getGammaExtensionSring()
				getCurrentImages()
				updateTheIconPreviewImage()
				openImageToolbar()
			)
		)
		
		on check_HighQualityIcons changed state do
		(
			setapref =  setINISetting CurrentINI "Toolbar Settings" "High-Quality Icons" (state as string )
			--if state do messagebox "High-Quality Icons are slow to render, once rendered though, the icons are reused unless the contents of the directory are changed."
		)
		
		on spin_MaxX changed newvalue do
		(
			setapref =  setINISetting CurrentINI "Toolbar Settings" "Max X" (newvalue as string )
		)
		on spin_MaxX entered do
		(
			prepThenLaunchToolbar()
		)
			
		on spin_MaxY changed newvalue do
		(
			setapref =  setINISetting CurrentINI "Toolbar Settings" "Max Y" (newvalue as string )
		)
		on spin_MaxY entered do
		(
			prepThenLaunchToolbar()
		)		
		
		on spin_ImageLimit changed newvalue do
		(
			setapref =  setINISetting CurrentINI "Toolbar Settings" "Image Limit" (newvalue as string )
		)
		on spin_ImageLimit entered do
		(
			prepThenLaunchToolbar()
		)		
			
		on but_ImageLocation pressed do
		(
			if keyboard.controlpressed then
			(
				try 
				(
					shellLaunch "explorer.exe" ImageBar_FilePath
				)
				catch
				(
					messagebox "Sorry, couldn't open that directory."
				)
			)
			else
			(
			
				beebee=undefined
				beebee = getSavePath initialDir:ImageBar_FilePath historyCategory:"automat_ImageBar" \
					caption:"Select the directory folder you'd like to use for ImageBar" 
				
				if undefined != beebee do
				(
					ImageBar_FilePath = beebee + "\\"
					--------------

					setapref =  setINISetting CurrentINI "Toolbar Settings" "Directory Location" (  "\"" + ImageBar_FilePath as string + "\"" )
					--------------
				)
				--
				getImageBarDirectories()
				drop_PickImageBar.items = ImageBarNames	
				text_Location.text = LocationName
				BAR_prefs.pickdir = Roll_automat_ImageBAR.drop_PickImageBar.selection = 1
				if ToolBarIsOpen do prepThenLaunchToolbar()
			)
		)
		--------------
		on but_ImageLocation rightclick do
		(
			if ( querybox "Reset Automat Imagebar to use default directory?\n\n...maxroot\maps\ImageBar\\" ) do
			(
				ImageBar_FilePath = (  (getdir #maxroot)+"\\maps\\ImageBar\\" )
				setapref =  setINISetting CurrentINI "Toolbar Settings" "Directory Location" (  "\"" + ImageBar_FilePath as string + "\"" )
				--
				
				getImageBarDirectories()
				drop_PickImageBar.items = ImageBarNames
				text_Location.text = LocationName	
				BAR_prefs.pickdir = Roll_automat_ImageBAR.drop_PickImageBar.selection = 1
				if ToolBarIsOpen do prepThenLaunchToolbar()
			)				
		)
		
		--------------
		on but_RebuildIcons pressed do
		(
			usergammaonornot = IDisplayGamma.colorCorrectionMode --gets the current user gamma mode
			IDisplayGamma.colorCorrectionMode = #none --TURN OFF GAMMA for rebuild since I can't find any gamma-safe way to build icons
			
			getIBprefs()

			
			getCurrentImages()
			
			buildNewIcons()
			
			--need to reload iconbar images
			updateTheIconPreviewImage()
			
			getGammaExtensionSring()
			
			openImageToolbar()
			ToolBarIsOpen = true
			
			IDisplayGamma.colorCorrectionMode = usergammaonornot --restores the user's gamma mode.
			--
			
		)
		
		
	)--END rollout
	
	
	--FUNCTIONS
	--/////////////////////////////////////////////
	--------------------------------------------------------

	--------------------------------------------------------
	function getIBprefs =
	(
		BAR_prefs.pickdir = Roll_automat_ImageBAR.drop_PickImageBar.selection
		BAR_prefs.highqualityicons = Roll_automat_ImageBAR.check_HighQualityIcons.state
		BAR_prefs.maxX = Roll_automat_ImageBAR.spin_MaxX.value
		BAR_prefs.maxY = Roll_automat_ImageBAR.spin_MaxY.value
		BAR_prefs.ImageLimit = Roll_automat_ImageBAR.spin_ImageLimit.value
		
		--format "BAR_prefs.pickdir: %\n" BAR_prefs.pickdir
	)
	
	--------------------------------------------------------
	function getGammaExtensionSring =
	(
		try
		(
			if #gamma == IDisplayGamma.colorCorrectionMode and fileInGamma >= 1.8 then GammaExtensionSring = "_22" 
					else GammaExtensionSring = "" 
		)
		catch ( GammaExtensionSring = ""  )
	)
	
	--------------------------------------------------------
	fn getImageBarDirectories =
	(
		ImageBarDirectories = #()	--RESET ARRAY
		ImageBarNames = #()	--RESET ARRAY
		
		--GET DIRECTORY PATHS
		ImageBarDirectories = getDirectories ( ImageBar_FilePath + "\\*" )
		startofpath = substring ImageBar_FilePath 1 3
		LocationName = startofpath + " ...\\" + ( getTheLastElementNameInFileAddress ImageBar_FilePath )
		
		--THEN NAMES
		ImageBarDirCount = ImageBarDirectories.count --gonna use this count later
		if 0 != ImageBarDirCount do
		(
			for loop = 1 to ImageBarDirCount do --do for each Directory
			(
				ImageBarNames[loop] = getTheLastElementNameInFileAddress ImageBarDirectories[loop]
			)
		)
	)	
	
	--------------------------------------------------------
	function getCurrentImages =
	(
		
		if 0 != ImageBarDirCount do
		(
			--------------
			--if before max 2013 then feck with gamma
			if currentMaxVersion < 15 do
			(
				tempingamma = fileInGamma
				fileInGamma = 1
			)
			--------------
			--GET FULL PATHS FOR EACH ICON
			CurrIcons = getFiles ( ImageBarDirectories[BAR_prefs.pickdir] + "\\*.jpg" )
			--get more types of files
			for each in MoreExt do --MoreExt is an array of additional file extension types
			(
				moreicons = getFiles ( ImageBarDirectories[BAR_prefs.pickdir] + "\\*." + each )
				for peep in moreicons do append CurrIcons peep
			)
			
			--------------
			IconCount = CurrIcons.count
			
			-- Let's limit the count based on image limit setting
			if IconCount > BAR_prefs.ImageLimit then
			(
				RejectedImageCount = IconCount - BAR_prefs.ImageLimit
				IconCount = BAR_prefs.ImageLimit
				
			)
			
			--GET BIGS
			if 0 != iconcount do
			(
				
				--
				for each in CurrBigs do close each
				CurrBigs=#()
				--------------
				gc() -- clear out old stuff
				--------------
				maxX = BAR_prefs.maxX
				maxY = BAR_prefs.maxY
				
				for loop = 1 to IconCount do
				(
					--stringparse = substituteString   CurrIcons[loop] "_icon" "" --RESORE THIS GammaExtensionSring --SUBTRACT "_icon" from string
					tempmap = OpenBitMap ( CurrIcons[loop] ) 
					theX = newX = tempmap.width
					theY = newY = tempmap.height
					theaspect = theX / ( theY as float )
					
					
					
					if theX > maxX then
					(
						newX = maxX
						newY = ( newX / theaspect ) as integer
					)
					 
					
					if newY > maxY then
					(
						newY = maxY
						newX = ( newY * theaspect ) as integer
					)
					
					
					--newmap = bitmap tempmap.width tempmap.height 
					newmap = bitmap newX newY
					copy tempmap newmap
					CurrBigs[loop] = newmap
					--CurrBigs[loop] = OpenBitMap ( stringparse ) 
				)
				
				
				--/////////////////////////////////////////////
				--DO SOME ERROR CHECKING HERE
				--/////////////////////////////////////////////
			)

			automat_ImageToolbarBig = CurrBigs[1] --set first image as default
			
			--ICONS
			--updateTheIconPreviewImage() --made this a separate function because I need to call it after the icons are rerendered
			
			--------------
			if currentMaxVersion < 15 do fileInGamma = tempingamma
		)
		
	)
	
		--------------------------------------------------------
	function updateTheIconPreviewImage =
	(
		--if before max 2013 then feck with gamma
			if currentMaxVersion < 15 do
			(
				tempingamma = fileInGamma
				fileInGamma = 1
			)
		
		TempMap = OpenBitMap ( ImageBarDirectories[BAR_prefs.pickdir] + "\\Icons" + "" + ".bmp" )  --REMOVED GAMMA STRIN?G
		if undefined == tempmap or TempMap.width != (IconCount * 64) do
		(
			--Roll_automat_ImageBAR.but_LaunchToolbar.caption = "Rendering Icons..."
			buildNewIcons()
		)
		if undefined != TempMap do
		(
			newmap = bitmap tempmap.width tempmap.height 
			copy tempmap newmap
			ToolbarIconImage = newmap
		)
		
		--restore gamma setting if needed
		if currentMaxVersion < 15 do fileInGamma = tempingamma
		
		
	)
	

	--------------------------------------------------------
	function prepThenLaunchToolbar =
	(
		getIBprefs()
		getGammaExtensionSring()
		getCurrentImages()
		openImageToolbar()
		ToolBarIsOpen = true
		
	)
	
	--------------------------------------------------------
	function prepThenLaunchToolbar =
	(
		getIBprefs()
		getGammaExtensionSring()
		getCurrentImages()
		updateTheIconPreviewImage()
		openImageToolbar()
		ToolBarIsOpen = true
		
	)
	
	--------------------------------------------------------
	function updateIconProgBar BuildIconProgress =
	(
		--Roll_automat_ImageBAR.prog_Imagebar.enabled = true
		--Roll_automat_ImageBAR.prog_Imagebar.value = BuildIconProgress
		--Roll_automat_ImageBAR.but_LaunchToolbar.caption = ( BuildIconProgress as string + "%" )
		--redrawViews()
		--this fumction sucks

	)
	--------------------------------------------------------
	function buildNewIcons =
	(
		if IconCount > 0 do
		(
			
			
				
			pushPrompt "Please wait while new icons are rendered . . . "
			
			--getCurrentImages() --this should help correct any issues when user changes gamma while imagebar is open, otherwise icons can render incorrectly

-- 			usersFileOutGamma = fileOutGamma
-- 			fileOutGamma = 2.2
-- 			
-- 			usersDisplayGamma = displayGamma --888888888888888888888888888888888888888888888888888
-- 			displayGamma = 2.2
			
			
				
			supergammakludge = ( if fileInGamma <=1 then 4.4 else 4.4 )
	
			TempMap = bitmap ( IconCount*64 ) 64 --gamma:1 --8888888888888888888888888888888888888888
			
			for iconloop = 1 to IconCount do
			(
				currmap = CurrBigs[iconloop]

				cw = currmap.width
				ch = currmap.height
				aspect = cw / ( ch as float )
				xoffset = ((iconloop-1) * 64)
				--
				if cw > ch then --WIDE
				(
					--scale height to proper size and then trim width
					nw = (aspect * 64 ) as integer
					rightheightmap = bitmap nw 64 gamma:supergammakludge --SUPER-KLUDGE. Can't stop max from destroying image gamma otherwise
					
					if BAR_prefs.highqualityicons then
					(
						currmap.filename = (getdir #temp) + "\\temp_iconbar.bmp"
									--format "currmap %\n\n" currmap
						save currmap
						tx = bitmaptexture bitmap:currmap
									--format "tx %\n\n" tx
						
						tx.reload() 
						
						rendermap tx into:rightheightmap filter:on display:off	
					)
					else copy currmap rightheightmap
					--
					pasteBitmap rightheightmap TempMap (box2 ((nw-64)/2) 0 64 64 ) [ xoffset ,0]
				)
				
				
				else if ch > cw then --TALL
				(
					--scale width and trim height
					nh = (1/aspect * 64 ) as integer
					rightwidthmap = bitmap 64 nh gamma:supergammakludge --SUPER-KLUDGE. Can't stop max from destroying image gamma otherwise
					
					if BAR_prefs.highqualityicons then
					(
						currmap.filename = (getdir #temp) + "\\temp_iconbar.bmp"
						save currmap
						tx = bitmaptexture bitmap:currmap
						
						tx.reload() 
						
						rendermap tx into:rightwidthmap filter:on display:off
					)
					else copy currmap rightwidthmap					
					
					--
					pasteBitmap rightwidthmap TempMap (box2 0 ((nh-64)/2) 64 64 ) [ xoffset ,0]
				)
				
				
				else --SQUARE
				(
					--same size
					easymap = bitmap 64 64 gamma:supergammakludge
					
					if BAR_prefs.highqualityicons then
					(
						currmap.filename = (getdir #temp) + "\\temp_iconbar.bmp"
						save currmap
						tx = bitmaptexture bitmap:currmap
						rendermap tx into:easymap filter:on display:off
					)
					else copy currmap easymap
					
					--
					pasteBitmap easymap TempMap (box2 0 0 64 64 ) [ xoffset ,0]
				)

				--SAVE MAP AS Icons.png
				TempMap.filename = ( ImageBarDirectories[BAR_prefs.pickdir] + "\\Icons.bmp" )
				
				
				save TempMap
				
				--8888888888888888888888888888888888888
				--IDisplayGamma.colorCorrectionMode = userGammaMode
				
				
				
				
				--------------
				--BuildIconProgress = 100.0 * iconloop/IconCount
				--updateIconProgBar BuildIconProgress
				--------------
				
			)--END iconloop
			
-- 			fileOutGamma = usersFileOutGamma
-- 			
-- 			displayGamma = usersDisplayGamma
		
			popPrompt()
			displayTempPrompt "DONE! New icons finished rendering." 2000
		)
		--print "\nDONE!          "
		
		gc() --Don't know if this is the right thing to do or not. ???
	)
	
	--------------------------------------------------------
	function makeABigPrettyWindow =
	(
		try( destroyDialog automat_IT_PrettyPicture ) catch()
		
		createDialog automat_IT_PrettyPicture automat_ImageToolbarBig.width automat_ImageToolbarBig.height  \
		bitmap:automat_ImageToolbarBig style: #( #style_border )
		currentbarpos = getDialogPos automat_ImageToolbar
		SetDialogPos automat_IT_PrettyPicture  [ currentbarpos.x - 4, currentbarpos.y - (automat_ImageToolbarBig.height) - 11 ]	
		
	)
	
	--------------------------------------------------------
	function openImageToolbar =
	(
		try( destroyDialog automat_IT_PrettyPicture ) catch()
		rollout automat_IT_PrettyPicture "BIG"
		(
		)	
					
		try( destroyDialog automat_ImageToolbar ) catch()
		
		--
		if 0 == IconCount do
		(
			if 0 == BAR_prefs.pickdir then dirmessage = ""
				else	dirmessage =ImageBarDirectories[BAR_prefs.pickdir]	--fix issue when no valid selection exists
			displaytext = "No pictures in selected directory:\n\n" + dirmessage
			messagebox displaytext
			return()
		)
		--
		rollout automat_ImageToolbar "Automat Imagebar"
		(
			on automat_ImageToolbar moved NewPos do
			(
				BAR_prefs.toolbarpos = NewPos
				setapref =  setINISetting CurrentINI "Toolbar Settings" "Position" (NewPos as string )
			)
			--------------
			on automat_ImageToolbar open do
			(
				ToolBarIsOpen = true
			)
			--------------
			on automat_ImageToolbar close do
			(
				ToolBarIsOpen = false
				for each in CurrBigs do close each
				automat_ImageToolbar = undefined
				gc() -- clear out old stuff
			)
			--------------
			on automat_ImageToolbar lbuttondown MousePos do
			(	
				MyMouseDown = true
				rejectstring = if 0 == RejectedImageCount then "." else ". " + RejectedImageCount as string + " images not included."
				pushPrompt ( "Automat Imagebar: " + ImageBarNames[BAR_prefs.pickdir] + rejectstring )
				
				--Check for gamma change
				--------------------------------------------------------
				oldgammastring = GammaExtensionSring
				getGammaExtensionSring()
				if oldgammastring != GammaExtensionSring do
				(
					getCurrentImages() --reget images because gamma settings require diff images	
					updateTheIconPreviewImage()
				)
				--------------------------------------------------------
				
				--changes to the toolbar display itself
				--------------------------------------------------------
				automat_ImageToolbar.width = ToolbarIconImage.width --512 --expand to fit number of icons

				--------------------------------------------------------
				makeABigPrettyWindow()
				--------------------------------------------------------
			)
			
			
			local LastX = 0
			local CurrX
			--------------------------------------------------------
			on automat_ImageToolbar mousemove MousePos do if MyMouseDown do
			(
				ChangeImage = false
				--
				CurrX = ( ( MousePos.x as integer + 1 ) / 64 ) + 1
				--
				if CurrX > IconCount then CurrX = IconCount
					else if CurrX < 1 do CurrX = 1
			
				
				if LastX  != CurrX do ChangeImage = true
				--------------
-- 				format "MousePos: %\n" MousePos
				
				if ChangeImage do
				(
					LastX = CurrX 
					ChangeImage = false

					automat_ImageToolbarBig = CurrBigs[CurrX]
					
					makeABigPrettyWindow()
				)
			)

			on automat_ImageToolbar lbuttonup MousePos do
			(
				MyMouseDown = false
				ChangeImage = false
				--------------
				popPrompt() --get rid of ImageBar name display
				--------------
				if keyboard.controlpressed and keyboard.altpressed then
				(
					if querybox "Delete that file from disk?" do
					(
						close CurrBigs[CurrX]
						close automat_ImageToolbarBig
						trythis = deleteFile CurrIcons[CurrX]
						--format "trythis: %\n" trythis
						if trythis then
						(
							getIBprefs()
							getGammaExtensionSring()
							getCurrentImages()
							updateTheIconPreviewImage()
							openImageToolbar()
							ToolBarIsOpen = true
						)
						else messagebox "Sorry. Couldn't delete that file."
					)
					
				)
				else if keyboard.controlpressed do
				(
					--gamma 
					tempingamma = fileInGamma
					fileInGamma = 2.2
					if keyboard.shiftpressed then
					(
						--honor max and maxy limits
						display ( KeepImageAroundAwhile = ( CurrBigs[CurrX] )  )
					)
					else
					(
						display ( KeepImageAroundAwhile = (OpenBitMap ( CurrIcons[CurrX] ) ) )
					)
					fileInGamma = tempingamma
				)
				--------------
				try( destroyDialog automat_IT_PrettyPicture ) catch()
				automat_ImageToolbar.width = 64
			)
			
			--------------------------------------------------------
			on automat_ImageToolbar rbuttondown MousePos do
			(
				if keyboard.controlpressed then
				(
					if BAR_prefs.pickdir > 1 then BAR_prefs.pickdir -= 1
						else BAR_prefs.pickdir = ImageBarDirCount -- cycle thru
				)
				else if BAR_prefs.pickdir < ImageBarDirCount then BAR_prefs.pickdir += 1
					else BAR_prefs.pickdir = 1

				Roll_automat_ImageBAR.drop_PickImageBar.selection = BAR_prefs.pickdir
				--
				getIBprefs()
				getGammaExtensionSring()
				getCurrentImages()
				updateTheIconPreviewImage()
				openImageToolbar()
				
				displayTempPrompt ( "Automat Imagebar: " + ImageBarNames[BAR_prefs.pickdir] ) 4000
			)
			
			--------------------------------------------------------
			on automat_ImageToolbar mbuttondown MousePos do
			(
				if BAR_prefs.pickdir > 1 then BAR_prefs.pickdir -= 1
					else BAR_prefs.pickdir = ImageBarDirCount -- cycle thru

				Roll_automat_ImageBAR.drop_PickImageBar.selection = BAR_prefs.pickdir
				--
				getIBprefs()
				getGammaExtensionSring()
				getCurrentImages()
				updateTheIconPreviewImage()
				openImageToolbar()
				
				displayTempPrompt ( "Automat Imagebar: " + ImageBarNames[BAR_prefs.pickdir] ) 4000
			)
			
		)
		
		
		--------------
		--Image Toolbar
		--------------
		if undefined !=  BAR_prefs.toolbarpos then createDialog automat_ImageToolbar \
			64 64 BAR_prefs.toolbarpos.x BAR_prefs.toolbarpos.y \
			bitmap:ToolbarIconImage bmpstyle: #bmp_tile
		--------------
			else createDialog automat_ImageToolbar 64 64  \
			bitmap:ToolbarIconImage  bmpstyle: #bmp_tile


	)
	
	
	if true != automat_OpenScriptAsRollout then
	(
		try (closeRolloutfloater automat_ImageBAR ) catch ()
		automat_ImageBAR = newRolloutFloater "Automat Imagebar" 170 102
		addRollout roll_automat_ImageBAR automat_ImageBAR
		automat_ImageBAR.size.y = ( roll_automat_ImageBAR.height + 30 )
	)
	else()
)