
--	MatchObjectTools.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.3
--	CREATED:	02-19-2011 --3dsmax 2011

--3-16-2014  Removed lame Find Match features
--1-21-12	Added ini to save and load settings
--5-3-11	Added Find Match feature
--4-27-2011	Added Match wirecolor
-- 3-6-11 changed ObjArray to include all valid nodes
-- 2-21-2011 started adding replace object tools
-- 9-1-11 match name function

(
	global automat_MatchObjectTool
	global roll_automat_MatchObjectTool
	
	--
	
	local CurrentINI = GetDir #plugcfg + "\\automat_MatchTools.ini"
	
	--
	
	local enableMatchObject
	local matchObject_automat
	
	local FindMatchProps=#()
	local FindMatchObject
	local FoundObjArray
	
	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout roll_automat_MatchObjectTool "Match Tools"
	(
		group "Match to Picked Object:"
		(
			pickButton but_MatchObject "Match Object..."  height:16 enabled:true \
			tooltip: "First select the objects you want to affect, choose the settings you want to match, and then Click this button to pick the match-to object."
					
			checkbox check_MatchPosition "Pos." tooltip:"" height:16 checked:true across:3
			checkbox check_MatchRotation "Rot." tooltip:"" height:16 offset:[2,0]
			checkbox check_MatchScale "Scale" tooltip:"" height:16 offset:[4,0]
			
			checkbox check_Pivot "Pivot" tooltip:"" height:16 across:2
			checkbox check_MatchMat "Material" tooltip:"" height:16 
			checkbox check_Wire "Wirecolor" tooltip:"" height:16 
			--checkbox check_AllObjectProperties "ALL Object Properties!!!" height:16
			
		)
		
		
			--INI related
		--------------------------------------------------------
		on roll_automat_MatchObjectTool open do
		(
			
			--------------
			getapref =  execute ( getINISetting CurrentINI "Checkbox States" "Position" )
			if getapref != OK do check_MatchPosition.checked = getapref
				
			getapref =  execute ( getINISetting CurrentINI "Checkbox States" "Rotation" )
			if getapref != OK do check_MatchRotation.checked =  getapref
				
			getapref =  execute ( getINISetting CurrentINI "Checkbox States" "Scale" )
			if getapref != OK do check_MatchScale.checked =  getapref
				
			getapref =  execute ( getINISetting CurrentINI "Checkbox States" "Pivot" )
			if getapref != OK do check_Pivot.checked =  getapref
				
			getapref =  execute ( getINISetting CurrentINI "Checkbox States" "Material" )
			if getapref != OK do check_MatchMat.checked =  getapref
				
			getapref =  execute ( getINISetting CurrentINI "Checkbox States" "Wirecolor" )
			if getapref != OK do check_Wire.checked =  getapref

		)
		
		on roll_automat_MatchObjectTool close do
		(
			
			--------------
			
			setapref =  setINISetting CurrentINI "Checkbox States" "Position" ( check_MatchPosition.checked as string )
			setapref =  setINISetting CurrentINI "Checkbox States" "Rotation" ( check_MatchRotation.checked as string )
			setapref =  setINISetting CurrentINI "Checkbox States" "Scale" ( check_MatchScale.checked as string )
			setapref =  setINISetting CurrentINI "Checkbox States" "Pivot" ( check_Pivot.checked as string )
			setapref =  setINISetting CurrentINI "Checkbox States" "Material" ( check_MatchMat.checked as string )
			setapref =  setINISetting CurrentINI "Checkbox States" "Wirecolor" ( check_Wire.checked as string )
			
			

		)
	
		on but_MatchObject picked PickedObj do
		(
			if PickedObj != undefined and selection != undefined do
			(
				--COLLECT INFO ON PICKED OBJECT
				
				--GET STATE OF CHECK BUTTONS
				MatchObjectCheckStates = #() --RESET
				MatchObjectCheckStates[1] = check_MatchPosition.checked
				MatchObjectCheckStates[2] = check_MatchRotation.checked
				MatchObjectCheckStates[3] = check_MatchScale.checked
				MatchObjectCheckStates[4] = check_MatchMat.checked
				MatchObjectCheckStates[5] = check_Pivot.checked
				MatchObjectCheckStates[6] = check_Wire.checked
				
				--CALL FUNCTION
				matchObject_automat selection PickedObj MatchObjectCheckStates 
			)
				PickedObj = undefined
		)
		
		--------------------------------------------------------
		
		
		--------------------------------------------------------
		
		
		--------------------------------------------------------
		
		
			
	) --ROLLOUT

		--Functions
		--/////////////////////////////////////////////
		--------------------------------------------------------
	function matchObject_automat selection PickedObj MatchObjectCheckStates =
	(
		if PickedObj != undefined and selection != undefined do
		(
			objArray = for piggy in selection where true == isValidNode(piggy)  collect piggy
			
			undo on
			(
					
				if MatchObjectCheckStates[2] == true do --ROTATION
				(
					for tweety in ObjArray do
					(
						OrigPos = tweety.pos
						tweety.rotation = PickedObj.rotation
						tweety.position = OrigPos
					)
				)
				
				if MatchObjectCheckStates[1] == true do --POSITON
				(
					for tweety in ObjArray do
					(
						tweety.pos = PickedObj.pos
					)
				)
				
				if MatchObjectCheckStates[3] == true do --SCALE
				(
					for tweety in ObjArray do
					(
						tweety.scale = PickedObj.scale
					)
				)
				
				if MatchObjectCheckStates[4] == true do --MATERIAL
				(
					for tweety in ObjArray do
					(
						tweety.material = PickedObj.material
					)
				)
				
				if MatchObjectCheckStates[5] == true do --PVIOT
				(
					for tweety in ObjArray do
					(
						tweety.pivot = PickedObj.pivot
					)
				)
				
				if MatchObjectCheckStates[6] == true do --wirecolor
				(
					for tweety in ObjArray do
					(
						tweety.wirecolor = PickedObj.wirecolor
					)
				)
				
				
				
			)
		)
		
	)
	
	if true != automat_OpenScriptAsRollout then
	(
		try (closeRolloutfloater automat_MatchObjectTool ) catch ()
		automat_MatchObjectTool = newRolloutFloater "Match Object Tool" 170 102
		addRollout roll_automat_MatchObjectTool automat_MatchObjectTool
		automat_MatchObjectTool.size.y = ( roll_automat_MatchObjectTool.height + 30 )
	)
	else()
	
	
)
