
--	MirrorTool.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.0
--	CREATED:	02-19-2011 --3dsmax 2011
--	MODIFIED:	08-08-2012 --3dsmax 2013
(
	global automat_MirrorTool
	
	local CurrentINI = GetDir #plugcfg + "\\Automat_MirrorTool.ini"
	--------------------------------------------------------
	local ImageLocation =  (  (getdir #userScripts)+"\BurkeStudios\images" )
	
	if true != BurkeLibLoaded do include "$userScripts/BurkeStudios/lib/BurkeLib.ms"
	
-- 	--GAMMA safe images
-- 	tempingamma = fileInGamma
-- 	fileInGamma = 1
-- 	tempopen = OpenBitMap  ( (ImageLocation)+"\BURKE_MirrorLEFT.bmp")
-- 	local img_mirrorLeft = bitmap tempopen.width tempopen.height
-- 	copy tempopen img_mirrorLeft
-- 	--
-- 	tempopen = OpenBitMap  ( (ImageLocation)+"\BURKE_MirrorRIGHT.bmp")
-- 	local img_mirrorRight = bitmap tempopen.width tempopen.height
-- 	copy tempopen img_mirrorRight
-- 	--
-- 	fileInGamma = tempingamma
-- 	
	
	
	--GET gamma safe image
	
	getThisImage = ( (ImageLocation)+"\BURKE_MirrorLEFT.bmp")
	openAnyOldImageWithProperGamma getThisImage
	local img_mirrorLeft = returnThisImageFromAutomat
	--
	getThisImage = ( (ImageLocation)+"\BURKE_MirrorRIGHT.bmp")
	openAnyOldImageWithProperGamma getThisImage
	local img_mirrorRight = returnThisImageFromAutomat
	
	
	--------------

	--------------------------------------------------------
	local rad_MirrorInstanceAxis
	local MirrorModeRadioValue
	local MirrorButtonText=#()
		MirrorButtonText[1]=#("Mirror Left", "Mirror Right")
		MirrorButtonText[2]=#("Mirror Front", "Mirror Back")
		MirrorButtonText[3]=#("Mirr Bottom", "Mirror Top")
	local MirrorMinOrMax --determines whether the left or right mirror button is pressed
	local ObjMirrorArray=#()
	
	--INI variables
	--------------------------------------------------------
	local UseWirecolors = true
	local WireColor = [140,70,35]
	--
	local Check_WireColor
	local pick_MirrorWireColor
	--------------
	
	local ObjArray
	
	--Function Names
	--------------------------------------------------------
	local getObjArrayCollectGeometry
	local getObjArrayCollectMirrorable

	local getOnlyMirroredInstances
	local setMirrorModeButttonText
	local selectMirroredInstances
	local selectAllMirroredInstances
	local deleteAllMirroredInstances
	local setWireColorForAllMirroredObjects
	local mirrorInstancedObjects
	
	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout roll_automat_MirrorTool "Mirror Instance Tool"
	(
		imgtag img_mirrorleft1 "mirror left" bitmap: img_mirrorleft pos: [8,8] transparent: [255,0,255]
		imgtag img_mirrorright1 "mirror right" bitmap: img_mirrorright  pos: [77,8] transparent: [255,0,255]

		button but_MirrorModelToLeft "Mirror Left" width:65 offset:[-4,0] across:2 \
		tooltip:"Left-click: Mirrors Objects\n\nRight-click: Deletes existing mirrors of selection before creating new ones\n
All selected objects are reflected using the same axis, that is why this is useful.\n
The intention is that eyes, and other parts will reflect properly when half of a character model is mirrored.\n
Workflow Bonus: you can mirror your object without leaving Editable Poly sub-object mode."
			
		button but_MirrorModelToRight "Mirror Right"  width:72 offset:[3,0] \
		tooltip:"Left-click: Mirrors Objects\n\nRight-click: Deletes existing mirrors of selection before creating new ones\n
All selected objects are reflected using the same axis, that is why this is useful.\n
The intention is that eyes, and other parts will reflect properly when half of a character model is mirrored.\n
Workflow Bonus: you can mirror your object without leaving Editable Poly sub-object mode."
			
			
		Radiobuttons rad_MirrorInstanceAxis  labels:#("X" , "Y", "Z") columns:3 tooltip:"Choose the reflection axis."
		
		label label_SelectMirrors "Select All:" offset:[-26,1] 
		button but_SelectALLMirror "Mirror" width:42 align: #left offset:[-4,-3] tooltip:"Searches by name to select all mirrored objects in scene" across:3
		button but_SelectALLOriginals "Original"  width:50 offset:[0,-3] tooltip:"Selects all original objects of mirrors" across:2
		button but_SelectINVMirror "Invert" offset:[11,-3] width:40 tooltip:"Inverts selection between original objects and mirrors"
		
		button but_DeleteMirroredObjects "Delete Mirrors" \
			tooltip:"Deletes ALL mirrored objects in scene.\nCan be called from sub-object mode"\
			align: #left width:75 offset:[-4,0] across:2
		button but_RenameMirror "Rename..." width:60 offset:[11,0]  tooltip:"not implemented" enabled:false
		
		Checkbox Check_WireColor "Assign Color to Mirrors" checked:UseWirecolors tooltip:"Assign wireframe color to all mirrored objects."
		colorPicker pick_MirrorWireColor "Wireframe Color:" color:WireColor modal:false
		
		
		
		
		
		
		--FUNCTIONS
		--/////////////////////////////////////////////
		--------------------------------------------------------
		function setMirrorModeButttonText MirrorModeRadioValue=
		(
			local LeftButtonText, RightButtonText
			but_MirrorModelToLeft.caption=MirrorButtonText[MirrorModeRadioValue][1]
			but_MirrorModelToRight.caption=MirrorButtonText[MirrorModeRadioValue][2]
		)
		
		--------------
		function getObjArrayCollectGeometry selection=
		(
			objArray = for piggy in selection where superclassof(piggy) == GeometryClass collect piggy	--collect GEOMETRY
		)
			
		function getObjArrayCollectMirrorable selection=
		(
			objArray = for piggy in selection where superclassof(piggy) == GeometryClass or superclassof(piggy)==shape collect piggy	--collect GEOMETRY
		)
		
		--------------
		function getOnlyMirroredInstances selection =
		(	
			getObjArrayCollectMirrorable selection
			ObjMirrorArray=#() --gonna return this array of objects
			TempObjMirrorArray=#() --

			(
				for piggly = 1 to ObjArray.count do
				(	
					TempObjMirrorArray=for i in Objects where ( ( matchPattern i.name pattern: (ObjArray[piggly].name+"_Mirror<>*") ) == true) collect i
					for wiggly=1 to TempObjMirrorArray.count do append ObjMirrorArray TempObjMirrorArray[wiggly]
				)
				
				ObjMirrorArray
			)	
		)	
			
		--------------
		function selectMirroredInstances selection =
		(
			--This function assumes a selection named ObjArray has already been created
			if subobjectlevel ==0 or subobjectlevel==undefined do --dont select object if user is working in sub-object mode
			(
				clearSelection() --deselect all objects
				
				try
				(
					ObjMatchedInstancesArray=#()
					for i = 1 to ObjArray.count do
					(	
						SelectedObject=ObjArray[i]
						FoundMirrorInName=findstring  SelectedObject.name "_Mirror<>" --will return an integer if mirror is in name
						
						if FoundMirrorInName == undefined then \
						(
							ObjMatchedInstancesArray=for i in Objects where ( ( matchPattern i.name pattern: (SelectedObject.name+"_Mirror<>*") ) == true) collect i
							for i in ObjMatchedInstancesArray do selectMore i		
						)
							else selectMore (GetNodeByName ( replace SelectedObject.name  FoundMirrorInName 12 ""  ) ) --find base object
					)
				)
				catch(messagebox "oops")	
			)	
		)
			
		--------------
		function selectAllMirroredInstances  =
		(
			clearSelection() --deselect all objects
			ObjMatchedInstancesArray=for i in Objects where ( ( matchPattern i.name pattern:"*_Mirror<>*" ) == true) collect i
			for i in ObjMatchedInstancesArray do selectMore i
		)
		
		--------------
		function deleteAllMirroredInstances  =
		(
			undo on
			(
				ObjMatchedInstancesArray=for i in Objects where ( ( matchPattern i.name pattern:"*_Mirror<>*" ) == true) collect i
				for i in ObjMatchedInstancesArray do delete i
			)
			
		)
			
		--------------
		function setWireColorForAllMirroredObjects =
		(
				if Check_WireColor.checked == true do
			(
				getOnlyMirroredInstances Objects --returns ObjMirrorArray
				for peep in ObjMirrorArray do peep.wirecolor=pick_MirrorWireColor.color
			)
		)
			
			
		--MAIN mirror function
		--/////////////////////////////////////////////
		function mirrorInstancedObjects selection=
		(
			getObjArrayCollectMirrorable selection --get selection of geometry and shapes
			aaa=rad_MirrorInstanceAxis.state --just easier to work with
			
			SelectionMin=#(Selection.min.x,Selection.min.y,Selection.min.z)
			SelectionMax=#(Selection.max.x,Selection.max.y,Selection.max.z)
			
			undo on
				(
					for i = 1 to objArray.count do
					(
						CurrentObject = objArray[i] --cycle through selection of objects
						
						--putting x,y,z into arrays so that I can use the radio button (1,2,3) to correspond to the correct axis.
						CopyPivot=#(CurrentObject.pivot.x,CurrentObject.pivot.y,CurrentObject.pivot.z)
						
						
						if MirrorMinOrMax=="min" then MirrorReflectionPoint=SelectionMin
							else MirrorReflectionPoint=SelectionMax
						
						-- Temporarily set object pivot to min or max of selection before doing mirrored instance
						CurrentObject.pivot = [ MirrorReflectionPoint[1],MirrorReflectionPoint[2],MirrorReflectionPoint[3] ]
						
						--ADD MIRROR TO NAME IF NEEDED
						--/////////////////////////////////////////////
						TempObjName=CurrentObject.name
						CopyOfObjectName= copy CurrentObject.name
						
						
						FoundMirrorInName=matchPattern  TempObjName pattern:"*_Mirror<>*" --matchPattern is faster than findstring
						
						
						if FoundMirrorInName==false do append TempObjName "_Mirror<>000"
							--only adds mirror to name if needed, if mirror is already in name then max will renumber new files
						
						CurrentObject.name = TempObjName
						
						MirrorObject = instance CurrentObject --CREATE INSTANCE
						CurrentObject.name = CopyOfObjectName
						
						ReflectionSetter=#(1.0,1.0,1.0) --by default there is no reflection. All values are positive
						ReflectionSetter[aaa] *= -1 --this sets the appropriate axis (1,2,3) to -1
						
						scale MirrorObject [ ReflectionSetter[1],ReflectionSetter[2],ReflectionSetter[3] ] --scale the object across the appropriate axis
						MirrorObject.xray = CurrentObject.xray --COPY xray Status of original object
						
						--need to put pivots back in order
						--if the current value x y or z matches the axis mode then do math to fix axis, otherwise use the original pivot info
						RestorePivot=#()
						for beefy = 1 to 3 do
						(
							RestorePivot[beefy]=if aaa==beefy \
								then ( MirrorReflectionPoint[beefy]-( CopyPivot[beefy]-MirrorReflectionPoint[beefy] ) )
									else CopyPivot[beefy]
						)
						
						MirrorObject.pivot = [ RestorePivot[1],RestorePivot[2],RestorePivot[3] ]
						CurrentObject.pivot = [ CopyPivot[1],CopyPivot[2],CopyPivot[3] ]
					)
					
					setWireColorForAllMirroredObjects(); --ASSIGN WIRE COLOR AS NEEDED
				)

		)
			
			
			
		--BUTTONS
		--/////////////////////////////////////////////
		--------------------------------------------------------
		on rad_MirrorInstanceAxis changed MirrorModeRadioValue  do
		(
			setMirrorModeButttonText MirrorModeRadioValue
		)	
			
		--------------
		on but_MirrorModelToLeft pressed do 
		(
			MirrorMinOrMax="min"
			mirrorInstancedObjects selection
		)	
		on but_MirrorModelToLeft rightclick do 
		(
			getOnlyMirroredInstances selection
			for i in ObjMirrorArray do delete i
				
			MirrorMinOrMax="min"
			mirrorInstancedObjects selection
		)	
		
		--------------
		on but_MirrorModelToRight pressed do 
		(
			MirrorMinOrMax="max"
			mirrorInstancedObjects selection
		)	
		on but_MirrorModelToRight rightclick do 
		(
			getOnlyMirroredInstances selection
			for i in ObjMirrorArray do delete i
			
			MirrorMinOrMax="max"
			mirrorInstancedObjects selection
		)	
		
		--------------
		on but_SelectALLMirror pressed do
		(
			selectAllMirroredInstances()	
		)
		
		--------------
		on but_SelectALLOriginals pressed do
		(
			selectAllMirroredInstances()
			getObjArrayCollectGeometry selection
			selectMirroredInstances selection					
		)
		
		--------------
		on but_SelectINVMirror pressed do
		(
			getObjArrayCollectGeometry selection
			selectMirroredInstances selection	
		)
		
		--------------
		on but_DeleteMirroredObjects pressed do
		(
			deleteAllMirroredInstances()
		)
		
		
		--/////////////////////////////////////////////
		--/////////////////////////////////////////////
		--INI related
		--/////////////////////////////////////////////
		--------------------------------------------------------
		on roll_automat_MirrorTool open do
		(
			getapref = execute ( getINISetting CurrentINI "Mirror Settings" "UseWirecolors" )
			if getapref != OK do Check_WireColor.checked = ( UseWirecolors = getapref )
			pick_MirrorWireColor.enabled = UseWirecolors
			--------------
			getapref = execute ( getINISetting CurrentINI "Mirror Settings" "WireColor" )
			if getapref != OK do pick_MirrorWireColor.color = ( WireColor = getapref )	
		)
		--------------
		on Check_WireColor changed state do
		(
			UseWirecolors = state
			setapref =  setINISetting CurrentINI "Mirror Settings" "UseWirecolors" ( UseWirecolors as string )
			--------------
			if true == state then
			(
				pick_MirrorWireColor.enabled = true
				setWireColorForAllMirroredObjects()
			)
			else pick_MirrorWireColor.enabled = false
		)
		--------------
		on pick_MirrorWireColor changed NewColor do
		(
			setWireColorForAllMirroredObjects();
			WireColor = NewColor
			setapref =  setINISetting CurrentINI "Mirror Settings" "WireColor" ( WireColor as string )
		)
		--/////////////////////////////////////////////
		--/////////////////////////////////////////////
		
		
	)--END rollout
	
	
	if true != automat_OpenScriptAsRollout then
	(
		try (closeRolloutfloater automat_MirrorTool ) catch ()
		automat_MirrorTool = newRolloutFloater "Spin Scatter" 170 232
		addRollout roll_automat_MirrorTool automat_MirrorTool
		automat_MirrorTool.size.y = ( roll_automat_MirrorTool.height + 30 )
	)
	else ()
	
)
