
--	Nubbins.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.1

--	CREATED:	01-09-2012 --3dsmax 2012
-- MODIFIED: 03-21-2014 --3dsmax 2014 Added ability to reset nub location to default.

--Added support for .mse files
--added error-checking for script launching and success/error messages
-- Selectable, user configured macros for simple but annoying things like selecting certain objects or moving objects around, etc.
(
	global automat_Nubbins
	
	--------------------------------------------------------
	local CurrentINI = GetDir #plugcfg + "\\automat_Nubbins.ini"
	local DirectorySpecificINI
	--------------------------------------------------------
	if true != BurkeLibLoaded do include "$userScripts/BurkeStudios/lib/BurkeLib.ms"
		
	
	--Local variables
	--------------------------------------------------------
	--local icondir = (getdir #ui)+"\\Icons"
	local but_Nubbin0
	--local NubNamesInCurrDir =#() --Really just an array of filenames found in current directory. Nubbins are scripts.
	local Nubbins_FilePath = (  (getdir #userScripts) + "\\BurkeStudios\\nubbins\\" ) --default location
	local Current_DirNumber = 1 --Current selection number for directory dropdown
	local Last_DirNumber = 1
	--
	local Page_Number = 0 --this number is added to button numbers to select the proper script using only ten buttons. Starting value is 0. Increments and decrements by 10 (no. of buttons on interface)
	local ClearCustomDataFlag = false
	
	--UI variables
	--I suppose these are really constants, just need these to have a flexible UI
	local uihstart = 68
	local uihstep = 18 
	local uih1 = uihstart
	local uih2 = uihstart + uihstep
	local uih3 = uih2 + uihstep
	local uih4 = uih3 + uihstep
	local uih5 = uih4 + uihstep
	local uih6 = uih5 + uihstep +2 --Page arrow buttons
	--
	local uih7 = uih6 + uihstep + 8 --edit text box for directory location
	local uih8 = uih7 + uihstep + 3
	
	
	--Open Icons w/ proper gamma
	openBurkeIconsWithProperGamma()
	
	
	--Function Names
	--------------------------------------------------------
	local getNubbinsDirectories = undefined
		local LocationName
		local Nubbins_Directories --directory address array
		local Directories_Count
		local Nubbins_DirNames --directory names array
		local Nubbins_Names --scripts found in current directory
		local Nubbins_CurrentPageNumForEachDir =#() --array to store and retrieve current page number count
		--
	local updateUI
	--
	local getScriptNames
		local Found_Scripts =#()
		local Found_ScriptNames =#()
		local Script_Count
		local Found_ScriptNamesStripped =#()
		
		--
		local editScriptInfo
			local automat_NubScriptInfo
			local EditScript_RolloutPosition = [ 200, 200]
		--
	local assignButtonLabels
		local Array_of_ButtonInfo
	--
	local launchScriptFromButtonNumber
		local ScriptNumToEdit
		local ExactNameOfScriptToBeEdited
		local ButtonNumber
		local ScriptNumber
	--
	local seekNamesAndNotesInScripts
	
	--Paths
	--------------------------------------------------------
	

	
	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout roll_automat_Nubbins "Nubbins"
	(
		group "Nubbins!:"
		(
			dropDownList drop_ChooseNubDirectory "Choose a Collection:"  items:#("-") offset:[0,-2]
			
			--
			button but_Nubbin1 height:18 width:72 pos:[7,uih1]
			button but_Nubbin2 height:18 width:72  pos:[79,uih1]
			--
			button but_Nubbin3 height:18 width:72 pos:[7,uih2]
			button but_Nubbin4 height:18 width:72  pos:[79,uih2]
			--
			button but_Nubbin5 height:18 width:72 pos:[7,uih3]
			button but_Nubbin6 height:18 width:72  pos:[79,uih3]
			--
			button but_Nubbin7 height:18 width:72 pos:[7,uih4]
			button but_Nubbin8 height:18 width:72  pos:[79,uih4]
			--
			button but_Nubbin9 height:18 width:72 pos:[7,uih5]
			button but_Nubbin10 height:18 width:72  pos:[79,uih5]
			--
			button but_minus width:24 height:24 border:false enabled:true across:2 pos:[103,uih6] \
				images:#(Icons,"$userIcons\BURKE-Icons2_24a.bmp", IconsInFile,13,13,14,14, true ) tooltip:"previous page"
			
			button but_plus width:24 height:24 border:false enabled:true across:2 pos:[127,uih6] \
				images:#(Icons,"$userIcons\BURKE-Icons2_24a.bmp", IconsInFile,11,11,12,12, true ) tooltip:"next page"
			--
			editText text_NubDirText text:"default" readonly:true width:145 pos:[4,uih7] border:false
			--
			button but_Location "Location..." width:72 pos:[7,uih8] tooltip:"Click to set a new location for Nubbins to find maxscripts.\n\nCTRL-Click to restore default directory location."
			
			button but_help width:24 height:24 border:false enabled:true  pos:[122,uih8] tooltip:"help!" \
				images:#(Icons,"$userIcons\BURKE-Icons2_24a.bmp", IconsInFile,2,2,2,2, true )

		)
		
		
		--/////////////////////////////////////////////
		--OPEN
		--/////////////////////////////////////////////
		--------------------------------------------------------
		on roll_automat_Nubbins open do
		(
			--
			getapref = ( getINISetting CurrentINI "Nubbins Settings" "Directory Location" ) as string
			if getapref != "" do Nubbins_FilePath = getapref
			--
			getapref = execute ( getINISetting CurrentINI "Nubbins Settings" "Current Directory Number" )
			if getapref != OK do Current_DirNumber = getapref
			
			--
			getNubbinsDirectories()
			drop_ChooseNubDirectory.selection = Current_DirNumber
			--
			
			updateUI()
			
			
		)
		
		on roll_automat_Nubbins close do
		(
			try( closeRolloutfloater automat_NubScriptInfo ) catch()
		)
			
			
		
		--BUTTONS
		--/////////////////////////////////////////////
		--------------------------------------------------------
		on but_Nubbin1 pressed do launchScriptFromButtonNumber 1
		on but_Nubbin2 pressed do launchScriptFromButtonNumber 2
		on but_Nubbin3 pressed do launchScriptFromButtonNumber 3
		on but_Nubbin4 pressed do launchScriptFromButtonNumber 4
		on but_Nubbin5 pressed do launchScriptFromButtonNumber 5
		on but_Nubbin6 pressed do launchScriptFromButtonNumber 6
		on but_Nubbin7 pressed do launchScriptFromButtonNumber 7
		on but_Nubbin8 pressed do launchScriptFromButtonNumber 8
		on but_Nubbin9 pressed do launchScriptFromButtonNumber 9
		on but_Nubbin10 pressed do launchScriptFromButtonNumber 10
			
		
	
		--------------------------------------------------------
		on drop_ChooseNubDirectory selected item do
		(
			
			Current_DirNumber = drop_ChooseNubDirectory.selection
			--
			
			
			--strore/retreive the Page_Number only when a new diretory is chosen
			--what page of buttons the user sees is only stored until the rollout is closed.
			if Current_DirNumber != Last_DirNumber do
			(
				Nubbins_CurrentPageNumForEachDir [ Last_DirNumber ] = Page_Number
				Page_Number = Nubbins_CurrentPageNumForEachDir [ Current_DirNumber ]
				
			)
			--
			setapref = setINISetting CurrentINI "Nubbins Settings" "Current Directory Number" ( Current_DirNumber as string  )
			
			--
			
			--
			updateUI()
			Last_DirNumber = Current_DirNumber
			
			
		) -- END rollout
		
		
		--/////////////////////////////////////////////
		on but_Location pressed do
		(
			if keyboard.controlpressed then
			(
				if querybox "Reset Nubbins location to default?" do try
					(
						Nubbins_FilePath = (  (getdir #userScripts) + "\\BurkeStudios\\nubbins\\")
						setapref =  setINISetting CurrentINI "Nubbins Settings" "Directory Location" (  "\"" + Nubbins_FilePath as string + "\"" )
						
					) catch( messagebox "Tried but couldn't find the default directory")
			)
			else
			(
					
				beebee=undefined
				beebee = getSavePath initialDir:Nubbins_FilePath historyCategory:"automat_ImageBar" \
					caption:"Select the directory folder you'd like to use for ImageBar" 
				
				if undefined != beebee do
				(
					Nubbins_FilePath = beebee + "\\"
					--------------

					setapref =  setINISetting CurrentINI "Nubbins Settings" "Directory Location" (  "\"" + Nubbins_FilePath as string + "\"" )
					--------------
				)
			)
			--
			getNubbinsDirectories() 
			updateUI()
			
		)
		--------------------------------------------------------
		
		on but_minus pressed do
		(
			if Page_Number > 0 do
			(
				Page_Number -= 10
				assignButtonLabels()
			)
				
		)
		
		on but_plus pressed do
		(
			--no error or limit checking yet
				Page_Number += 10
				assignButtonLabels()
		)
		
		--
		
		on but_help pressed do
		(
			
			messagestring = 
			(
				"Nubbins is an auto-populating button launcher for maxscripts.\n\n" + 
				"Use the default Nubbins directory or choose your own. Each directory within your selected Nubbins folder is listed as a collection in the interface. The scripts in those directories will be assigned to a button automatically. You can rename the actual script files to change the order in which they load and are assigned to buttons.\n\n" +
				"CTRL+Click on any of the buttons to edit name and tooltip description.\n\nCTRL+ALT+Click on a button to open associated script in maxscript editor."
				
			)
			
			messagebox messagestring
			
		)
		
		
		
	)--rollout
	
	
	
	rollout roll_automat_EditScriptInfo ( ExactNameOfScriptToBeEdited ) width:610 height:100
	(
		label lab_Name "Name:" pos:[12,8] width:152 height:16
		editText user_ScriptName "" pos:[8,24] width:80 height:18
		button but_Clear "Clear Custom Data" pos:[150,22]  height:24
		--
		--label lab_OriginalName "xxx.ms" pos:[180,8] width:88 height:16
		--
		label lab_Description "Description:" pos:[12,51] width:152 height:16
		editText user_ScriptDescription "" pos:[8,67] width:594 height:18
		
		button but_OK "OK" pos:[538,17] width:64 height:32
		button but_Cancel "cancel" pos:[488,17] width:50 height:32
		
		
		on roll_automat_EditScriptInfo open do
			
		(
			--populate text fields with current data
			user_ScriptName.text = Array_of_ButtonInfo [ ButtonNumber ] [1] 
			--
			user_ScriptDescription.text = Array_of_ButtonInfo [ ButtonNumber ] [2]

		)
		
		on roll_automat_EditScriptInfo moved ScreenPos do
		(
			setapref =  setINISetting CurrentINI "Edit Script Rollout" "RolloutPosition" (ScreenPos as string )
		)
	
		--
		
		on but_Cancel pressed do
		(
			try( closeRolloutfloater automat_NubScriptInfo ) catch()
		)
		
		--
		
		on but_OK pressed do
		(
			if true == ClearCustomDataFlag then
			(
				clearapref =  delIniSetting  DirectorySpecificINI ( ExactNameOfScriptToBeEdited )  "Name" 
				clearapref =  delIniSetting  DirectorySpecificINI ( ExactNameOfScriptToBeEdited )  "Description" 
				ClearCustomDataFlag = false
			)
			else
			(
				setapref =  setINISetting DirectorySpecificINI ( ExactNameOfScriptToBeEdited )  "Name" (  "\"" + user_ScriptName.text as string + "\"" )
				setapref =  setINISetting DirectorySpecificINI ( ExactNameOfScriptToBeEdited )  "Description" (  "\"" + user_ScriptDescription.text as string + "\"" )
			)
			--
			updateUI()
			--
			try( closeRolloutfloater automat_NubScriptInfo ) catch()
			
		)
		
		on but_Clear pressed do
		(
			ClearCustomDataFlag = true
			--
			user_ScriptName.text = Found_ScriptNamesStripped [ ScriptNumber ] 
			user_ScriptDescription.text = "Run script: " + ( ExactNameOfScriptToBeEdited )

		)
		
		
	)
		
		
	--FUNCTIONS
	--/////////////////////////////////////////////
	--------------------------------------------------------
	
	fn updateUI =
	(
		
		roll_automat_Nubbins.drop_ChooseNubDirectory.items = Nubbins_DirNames
		roll_automat_Nubbins.text_NubDirText.text = LocationName
		getScriptNames()
		assignButtonLabels()
	)
	--------------------------------------------------------
	fn getNubbinsDirectories =
	(
		Nubbins_Directories = #()	--RESET ARRAY
		Nubbins_DirNames = #()	--RESET ARRAY
		
		--GET DIRECTORY PATHS
		Nubbins_Directories = getDirectories ( Nubbins_FilePath + "\\*" )
		startofpath = substring Nubbins_FilePath 1 3
		LocationName = startofpath + " ...\\" + ( getTheLastElementNameInFileAddress Nubbins_FilePath )
		
		--THEN NAMES
		Directories_Count = Nubbins_Directories.count --gonna use this count later
		if 0 != Directories_Count do
		(
			for loop = 1 to Directories_Count do --do for each Directory
			(
				Nubbins_DirNames[loop] = getTheLastElementNameInFileAddress Nubbins_Directories[loop]
				if undefined == Nubbins_CurrentPageNumForEachDir[loop]  do Nubbins_CurrentPageNumForEachDir[loop] = 0 --ensuring that there is always a number in this array
			)
		)
		
		--let's error check the Current_DirNumber
		--this is loaded from an ini and can change and become invalid
		if Current_DirNumber > Directories_Count do Current_DirNumber = 1
		
		
	)

	
	fn getScriptNames =
	(
		Found_ScriptNames=#()
		Found_ScriptNamesStripped=#()
	
		--Creates an array of directory paths to any files with an .ms extension
		--Nubbins Directories holds an array of directories contained in the root of the main Nubbins directory
		Found_Scripts = getFiles ( Nubbins_Directories[Current_DirNumber] + "\\*.mse" )
		Script_Count = Found_Scripts.count
		--
		if 0 != Script_Count do
			(
				for each in Found_Scripts do
				(
					tempname =  ( getTheLastElementNameInFileAddress each )
					append Found_ScriptNames tempname
					--
					strippedname = substring tempname 1 ( tempname.count - 4 ) --strip off the .mse in the name
					append Found_ScriptNamesStripped strippedname
				)
					
			)
			--
		foundmorescripts = getFiles ( Nubbins_Directories[Current_DirNumber] + "\\*.ms" )
		morecount = foundmorescripts.count
			
			if 0 != morecount do
			(
				for each in foundmorescripts do
				(
					append Found_Scripts each
					Script_Count += 1
					
					tempname =  ( getTheLastElementNameInFileAddress each )
					append Found_ScriptNames tempname
					--
					strippedname = substring tempname 1 ( tempname.count - 3 ) --strip off the .ms in the name
					append Found_ScriptNamesStripped strippedname
				)
					
			)
			
			
			
			
	)
	
	fn assignButtonLabels =
	(
		
		--establish directory-specific ini file
		DirectorySpecificINI =  (  Nubbins_Directories [ Current_DirNumber ]  +  "\\_nubinfo.ini" )
		
		--we might need to change the current Page_Number
		--need to use an array that uses the directory number to store page numbers
		
	
		numofbuttonsonpage = Script_Count - Page_Number -- we need to subtract page number (0,10,20,etc.) to figure out how many buttons to make on current page
		
		--before updating buttons need to collect info into array
		-- label, tooltip, enabled t/f
		Array_of_ButtonInfo=#(#( "-", "", false ),#( "-", "", false ),#( "-", "", false ),#( "-", "", false ),#( "-", "", false ),#( "-", "", false ),#( "-", "", false ),#( "-", "", false ),#( "-", "", false ),#( "-", "", false ))
		
		if numofbuttonsonpage > 0 do
		(
				
				for num = 1 to numofbuttonsonpage do
			(
				tempcount = num + Page_Number --are we showing scripts 1-10 or some other page of scripts?
				temparray=#( "", "", false )
				
				--if we can find info about the current script in the ini file then we will use that info
				--otherwise we will just derive the info on the button labels and in the tooltip string from the filename
				
				ExactNameOfScriptToBeEdited  = Found_ScriptNames[ tempcount ]
				
				getapref = ( getINISetting DirectorySpecificINI ( ExactNameOfScriptToBeEdited ) "Name" ) as string
				if getapref != ""
					then temparray[1] = getapref
						else temparray[1] = Found_ScriptNamesStripped [ tempcount ] --this is the label of the button
				
				--
				
				getapref = ( getINISetting DirectorySpecificINI ( ExactNameOfScriptToBeEdited ) "Description" ) as string
				if getapref != ""
					then temparray[2] = getapref
						else temparray[2] = "Run script: " + ( ExactNameOfScriptToBeEdited ) -- this is the tooltip text
				
					
					temparray[3] = true --this is the enabled state of the button. 
					--
					Array_of_ButtonInfo[num] = temparray
				
				
	
			)
			
			
			
			
		)
		
		--
		
		
		roll_automat_Nubbins.but_Nubbin1.text = Array_of_ButtonInfo [1] [1]
		roll_automat_Nubbins.but_Nubbin1.tooltip = Array_of_ButtonInfo [1] [2]
		roll_automat_Nubbins.but_Nubbin1.enabled = Array_of_ButtonInfo [1] [3]
		--
		roll_automat_Nubbins.but_Nubbin2.text = Array_of_ButtonInfo [2] [1]
		roll_automat_Nubbins.but_Nubbin2.tooltip = Array_of_ButtonInfo [2] [2]
		roll_automat_Nubbins.but_Nubbin2.enabled = Array_of_ButtonInfo [2] [3]
		--
		roll_automat_Nubbins.but_Nubbin3.text = Array_of_ButtonInfo [3] [1]
		roll_automat_Nubbins.but_Nubbin3.tooltip = Array_of_ButtonInfo [3] [2]
		roll_automat_Nubbins.but_Nubbin3.enabled = Array_of_ButtonInfo [3] [3]
		--
		roll_automat_Nubbins.but_Nubbin4.text = Array_of_ButtonInfo [4] [1]
		roll_automat_Nubbins.but_Nubbin4.tooltip = Array_of_ButtonInfo [4] [2]
		roll_automat_Nubbins.but_Nubbin4.enabled = Array_of_ButtonInfo [4] [3]
		--
		roll_automat_Nubbins.but_Nubbin5.text = Array_of_ButtonInfo [5] [1]
		roll_automat_Nubbins.but_Nubbin5.tooltip = Array_of_ButtonInfo [5] [2]
		roll_automat_Nubbins.but_Nubbin5.enabled = Array_of_ButtonInfo [5] [3]
		--
		roll_automat_Nubbins.but_Nubbin6.text = Array_of_ButtonInfo [6] [1]
		roll_automat_Nubbins.but_Nubbin6.tooltip = Array_of_ButtonInfo [6] [2]
		roll_automat_Nubbins.but_Nubbin6.enabled = Array_of_ButtonInfo [6] [3]
		--
		roll_automat_Nubbins.but_Nubbin7.text = Array_of_ButtonInfo [7] [1]
		roll_automat_Nubbins.but_Nubbin7.tooltip = Array_of_ButtonInfo [7] [2]
		roll_automat_Nubbins.but_Nubbin7.enabled = Array_of_ButtonInfo [7] [3]
		--
		roll_automat_Nubbins.but_Nubbin8.text = Array_of_ButtonInfo [8] [1]
		roll_automat_Nubbins.but_Nubbin8.tooltip = Array_of_ButtonInfo [8] [2]
		roll_automat_Nubbins.but_Nubbin8.enabled = Array_of_ButtonInfo [8] [3]
		--
		roll_automat_Nubbins.but_Nubbin9.text = Array_of_ButtonInfo [9] [1]
		roll_automat_Nubbins.but_Nubbin9.tooltip = Array_of_ButtonInfo [9] [2]
		roll_automat_Nubbins.but_Nubbin9.enabled = Array_of_ButtonInfo [9] [3]
		--
		roll_automat_Nubbins.but_Nubbin10.text = Array_of_ButtonInfo [10] [1]
		roll_automat_Nubbins.but_Nubbin10.tooltip = Array_of_ButtonInfo [10] [2]
		roll_automat_Nubbins.but_Nubbin10.enabled = Array_of_ButtonInfo [10] [3]
		
		
		--------------------------------------------------------
		-- Now we need to update the page arrows
		-- need to say what page we are on
		-- if page_number +10 is less than script count then we can go forward
		-- if page_number is bigger than  zero than we can go backwards
		-- sometimes we can go both directions
		
		if ( Page_Number + 10 ) < Script_Count then roll_automat_Nubbins.but_plus.enabled = true 
			else roll_automat_Nubbins.but_plus.enabled = false
			
		if  Page_Number  > 0 then roll_automat_Nubbins.but_minus.enabled = true 
		else roll_automat_Nubbins.but_minus.enabled = false
		
		
		
		--------------------------------------------------------
		
		
	)
	
	function launchScriptFromButtonNumber buttonnum =
	(
		ScriptNumber = buttonnum + (Page_Number)
		ButtonNumber = buttonnum
		
		
		if keyboard.controlpressed and  keyboard.altpressed then
		(
			try ( edit ( Found_Scripts[ ScriptNumber ] ) )
			catch messagebox (getCurrentException())
		)
		else if keyboard.controlpressed then
		(
			ScriptNumToEdit = nummy
			ExactNameOfScriptToBeEdited = Found_ScriptNames [ ScriptNumber ]
			editScriptInfo()
		)
		else
		(
			 
			try 
			(
				fileIn  ( Found_Scripts[ ScriptNumber ] )
				popPrompt()
				displayTempPrompt ( Found_ScriptNames[ ScriptNumber ] + " launched successfully." ) 2000
			)
			catch
			(
				popPrompt()
				displayTempPrompt ( "Error launching script: " + Found_ScriptNames[ ScriptNumber ] ) 2000
				messagebox (getCurrentException())
	
			)
			--scriptfile = ( openFile ( Found_Scripts[ ScriptNumber ] ) )
			--execute scriptfile
			 
			
		)
		
	)
	
	function seekNamesAndNotesInScripts =
	(
-- 		scriptfile = (openFile ( Found_Scripts[1] ) ) --gotta FIX
-- 		skipToString scriptfile "$$name"
-- 		roll_automat_Nubbins.but_Nubbin1.text = readValue scriptfile
-- 		close scriptfile
	)
	
	function editScriptInfo =
	(
		try( closeRolloutfloater automat_NubScriptInfo ) catch()
		
		--
		
		getapref = execute ( getINISetting CurrentINI "Edit Script Rollout" "RolloutPosition" )
			if getapref != OK do EditScript_RolloutPosition = getapref
				
		--
			
		automat_NubScriptInfo = newRolloutFloater "Nubbins - Edit Script Info" 630 120  EditScript_RolloutPosition.x EditScript_RolloutPosition.y
		addRollout roll_automat_EditScriptInfo automat_NubScriptInfo
	
	)
	
	
	--------------------------------------------------------
	if true != automat_OpenScriptAsRollout do
	(
		try (closeRolloutfloater automat_Nubbins ) catch ()
		automat_Nubbins = newRolloutFloater "Nubbins" 170 90
		addRollout roll_automat_Nubbins automat_Nubbins
		automat_Nubbins.size.y = ( roll_automat_Nubbins.height + 30 )
	)
	
)
