
--	PivotControl.ms
--	Steve Burke
--	www.burkestudios.com

--	version 1.0
--	CREATED:	02-19-2011 --3dsmax 2011
--	MODIFIED:	02-19-2011 --3dsmax 2011

(
	global automat_PivotControl
	
	--Function Names
	--------------------------------------------------------
	local collectThingsWithPivots
	local setPivotPosition
	local ObjArray
	
	local PivotControlMode = "center"
	
	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout roll_automat_PivotControl "Pivot and Position Control"
	(
		group "Pivots:"
		(
			button but_TopPivot "top" tooltip:"Place Object Pivots at Top of each Object."   height:16 offset:[0,-6]
					
			button but_FrontPivot "front" tooltip:"Place Object Pivots at Front of each Object."  height:16 across:3 offset:[-4,-6]
			button but_CenterPivot "Center" tooltip:"Place Pivots at Center of each Object." 
			button but_BackPivot "back" tooltip:"Place Object Pivots at Back of each Object."  height:16  offset:[6,-6]
			
			button but_LeftPivot "left" tooltip:"Place Pivots at Left of each Object."  height:16 across:3 offset:[-4,-6]
			button but_BottomPivot "bottom" tooltip:"Place Pivots at Bottom of each Object."  height:16 
			button but_RightPivot "right" tooltip:"Place Pivots at Right of each Object." height:16 offset:[6,-6]
		)
			--checkbox check_affectPivotMode "Affect Pivot Only Mode"
		
		
		--Buttons
		--/////////////////////////////////////////////
		--------------------------------------------------------
		on but_TopPivot pressed do
		(
			format "Selection: %\n" Selection
			
			PivotControlMode = "top"
			setPivotPosition Selection				
		) 
			
		--------------
		on but_BottomPivot pressed do
		(
			PivotControlMode = "bottom"
			setPivotPosition Selection	
		) 
			
		--------------
		on but_CenterPivot pressed do
		(
			PivotControlMode = "center"
			setPivotPosition Selection	
		)
			
		--------------
		on but_BackPivot pressed do
		(
			PivotControlMode = "back"
			setPivotPosition Selection
		)
			
		--------------
		on but_FrontPivot pressed do
		(
			PivotControlMode = "front"
			setPivotPosition Selection
		)
			
		--------------
		on but_LeftPivot pressed do
		(
			PivotControlMode = "left"
			setPivotPosition Selection
		)
			
		--------------
		on but_RightPivot pressed do
		(
			PivotControlMode = "right"
			setPivotPosition Selection
		)
			
		--------------

		
		
	)
	
	--FUNCTIONS
	--/////////////////////////////////////////////
	--------------------------------------------------------
	function collectThingsWithPivots Selection =
	(
		objArray = for piggy in Selection where (try piggy.pivot != undefined catch(false)) collect piggy --OBJ has PIVOT?
	)
	
	function setPivotPosition Selection =
	(
		undo on
		(
			collectThingsWithPivots Selection
			for i = 1 to objArray.count do
			(
			CurrentObject = objArray[i]
			TempPivotX=CurrentObject.pivot.x
			TempPivotY=CurrentObject.pivot.y
			TempPivotZ=CurrentObject.pivot.z
			ObjectMin=CurrentObject.min
			ObjectMax=CurrentObject.max
			ObjectCenter=CurrentObject.center
				if PivotControlMode=="center" then CurrentObject.pivot = [ObjectCenter.x,ObjectCenter.y,ObjectCenter.z]
				if PivotControlMode=="top" then CurrentObject.pivot = [TempPivotX,TempPivotY,ObjectMax.z]
				if PivotControlMode=="bottom" then CurrentObject.pivot = [TempPivotX,TempPivotY,ObjectMin.z]
				if PivotControlMode=="left" then CurrentObject.pivot = [ObjectMin.x,TempPivotY,TempPivotZ]
				if PivotControlMode=="right" then CurrentObject.pivot = [ObjectMax.x,TempPivotY,TempPivotZ]
				if PivotControlMode=="back" then CurrentObject.pivot = [TempPivotX,ObjectMax.y,TempPivotZ]
				if PivotControlMode=="front" then CurrentObject.pivot = [TempPivotX,ObjectMin.y,TempPivotZ]
			)
		)
	)
	
	if true != automat_OpenScriptAsRollout then
	(
		try (closeRolloutfloater automat_PivotControl ) catch ()
		automat_PivotControl = newRolloutFloater "SplineTools" 170 102
		addRollout roll_automat_PivotControl automat_PivotControl
		automat_PivotControl.size.y = ( roll_automat_PivotControl.height + 30 )
	)
	else()
)