
--03-16-14 simplified tools and layout. moved some tools to nubbins. Added button to close all rollouts.
--4-29-13 First version made for 3ds max 2014
--1-27-12	Added In/Out button
--1-9-12	Added Nubbins
--5-5-11	Added Find DingleVerts to ModelDiag
--5-3-11	Updated remove tool and Objects tool
--4-25-11	added Export Objects to OBJs to Object Tools, Added xyz options to remove transforms tools
--4-13-2011 added build tool
--3-6-11 added gamma correct images for ui
--8-8-12	modified all scripts and libraries to support 2013 (image gamma and install directory issues resolved)

	
	
macroScript Automat
		category:"BurkeStudios"
		tooltip: "Automat"
		icon:#("BURKE-Icons2", 1)
		
(
	
	--INCLUDES
	--------------------------------------------------------
	if true != BurkeLibLoaded do include "$userScripts/BurkeStudios/lib/BurkeLib.ms"
	--
	local CurrentINI = GetDir #plugcfg + "\\automat.ini"
	--local AutomatImage =  OpenBitMap (  (getdir #scripts)+"\\BurkeStudios\\images\\Automat.bmp" )
	
	--get image dir
	local imagedir = (getdir #userScripts)+"\\BurkeStudios\\images"
	local AutomatImage
	
	local numopenrollouts = 0
	
	struct struct_FloatState
	(
		automat_GoldenRatio = false,
		automat_ImageBAR = false,
		automat_SpinScatter = false,
		
		automat_SubDivCalculator = false,
		automat_ModelZipper = false,
		automat_MirrorTool = false,
		automat_ObjectTools = false,
		--
		automat_MatchObjectTool = false,
		automat_RemoveTool = false,
		automat_ImageTool = false,
		automat_LayerCake = false,
		--
		automat_ModelDiag = false,
		automat_SplineTools = false,
		--
		automat_PivotControl = false,
		automat_MatSmoothTool = false,
		automat_JumbleTool = false,
		--
		automat_ObjCleaner = false,
		automat_SplodeTool = false,
		automat_JunkBoxTool = false,
		AboutAutomat = false,
		--
		rautomat_Nubbins = false,
		automat_ImportExportTools = false
	)
	
	global struct_FloatStates = struct_FloatState

	
	function getAutomatImage =
	(		
		--GAMMA safe images
		
		getThisImage = (  imagedir + "\\Automat.bmp" )
		openAnyOldImageWithProperGamma getThisImage
		AutomatImage = returnThisImageFromAutomat
		--------------
	)

	
	
	
	--ROLLOUT FLOATERS
	--------------------------------------------------------
	global automat_LauncherFloater
	global automat_ThisRollotY = 0
	local roll_LauncherButtons
	
	--Rollouts
	--------------------------------------------------------
	global roll_automat_GoldenRatio
	global roll_automat_ImageBAR
	global roll_automat_SpinScatter
	
	global roll_automat_SubDivCalculator
	global roll_automat_ModelZipper
	global roll_automat_MirrorTool
	global roll_automat_ObjectTools
	--
	global roll_automat_MatchObjectTool
	global roll_automat_RemoveTool
	global roll_automat_ImageTool
	global roll_automat_LayerCake
	--
	global roll_automat_ModelDiag
	global roll_automat_SplineTools
	--
	global roll_automat_PivotControl
	global roll_automat_MatSmoothTool
	global roll_automat_JumbleTool
	--
	global roll_automat_ObjCleaner
	global roll_automat_SplodeTool
	global roll_automat_JunkBoxTool
	local Roll_AboutAutomat
	--
	global roll_automat_Nubbins
	global roll_automat_ImportExportTools
	
	local QuietResize = false
	
	
	
	--Various
	--------------------------------------------------------
	global automat_OpenScriptAsRollout = false --true means that scripts open as rollout in Poly-G window, false, they get their own.
	local RollTarget = RollDefaultY = RollMin = ( 160 - 40)
	local bh = 20
	local r1 = 5
	local r2 = ( bh + r1 )
	local r3 = ( bh + r2 )
	local r4 = ( bh + r3 )
	local r5 = ( bh + r4 )
	local r6 = ( bh + r5 )
	local r7 = ( bh + r6 )

	
	--ini variables
	--------------------------------------------------------
	local RolloutMaxY = 780
	local RolloutPosition = [ 200, 200]

	--Function Prototypes
	--------------------------------------------------------
	local openOrCloseRollout
	local resizeautomat_LauncherFloater
	local closeAutomatRollouts
	local openOrCloseAboutBox
	
	--UI
	--/////////////////////////////////////////////
	--------------------------------------------------------
	rollout roll_LauncherButtons "Automat 2015"
	(
		
		--checkbutton check_GoldenRatio "Golden" height:bh width:40 pos:[2,r1]  tooltip:"Golden Ratio / Fibonacci Tools"
		checkbutton check_PivotControl "Pivots" height:bh width:38 pos:[2,r1]  tooltip:"Manipulate object pivots"
		checkbutton check_ImageBar "Imagebar" height:bh width:52 pos:[40,r1]  \
		tooltip:"Image Toolbar\n\nA streamlined and effortless way to organize and use art reference while you are working in max."
		checkbutton check_SpinScatter "SpinScatter" height:bh width:61 pos:[92,r1] tooltip:"Angle-based scatter tool.\nUse the golden mean to dynamically create organic and elaborate object scatters."
		--------------
		checkbutton check_MirrorTool " Mirror" height:bh  width:34 pos:[2,r2] tooltip:"Mirror Instance Objects\n
Primarily made for mirroring an Editable Poly model when modeling half of a character.\n
This tool can be used for general-purpose mirroring but because it uses a technique that is slow in maxscript it can appear to hang in scenes with many objects."
		checkbutton check_ModelZipper " Zipper" height:bh  width:37 pos:[36,r2]  tooltip:"Model Zipper.\nAutomatically zip two halves of a model together. This in combination with the mirror tool makes it super easy to assembly a full character in seconds while modeling with just one half."
		checkbutton check_SubObjectTools "Object" height:bh  width:44 pos:[73,r2]  tooltip:"Object Tools.\nSmall utilities for working with objects."
		checkbutton check_ImageTool "Image" height:bh width:36 pos:[117,r2]  tooltip:"Image Check tools. Gamma, ambient tools"
		--------------
		checkbutton check_ModelDiag "Model Diag" height:bh width:58 pos:[2,r3]  tooltip:"Used on objects it will help you find quad vs. non-quad objects. Used on a single Editable Poly, it will help you find, quads, tris, and ngons. Great for modeling cleanup."
		checkbutton check_MatSmoothTool "Mat/Smooth" height:bh width:63 pos:[60,r3]  tooltip:"Set/Select Material IDs and Smoothing groups"
		checkbutton check_Nubbins "Nub" height:bh width:30 pos:[123,r3]  tooltip:"Button-based script launcher.\nA quick way to organize and run maxscripts. Great as an ersatz interface for small project-based scripts; just drop a bunch of scripts in a Nub folder and the launcher buttons are automatically-generated." enabled: true
		--------------
		checkbutton check_MatchObjectTool "Match" height:bh width:38 pos:[2,r4]  tooltip:"Match object properties of selected objects to those of a picked object"
		checkbutton check_ObjCleaner "Cleaner" height:bh width:41 pos:[40,r4] tooltip:"The geometry for each object in selection is flattend to a clean Editable Poly and weird transforms and scales are cleaned away."
		checkbutton check_ImportExportTools "In/Out" height:bh width:42 pos:[81,r4]  tooltip:"Easily import and export multiple obj objects. Great for back and forth to ZBrush, UVLayout, etc."
		checkbutton check_About "?" height:bh width:15 pos:[123,r4]  tooltip:"About Automat"
		button but_CloseAll "-" height:bh width:15 pos:[138,r4]  tooltip:"Close all Automat rollouts." enabled:false

		
		on check_PivotControl changed state do openOrCloseRollout  "automat_PivotControl" state
		on check_ImageBAR changed state do openOrCloseRollout  "automat_ImageBAR" state
		on check_SpinScatter changed state do openOrCloseRollout  "automat_SpinScatter" state
		--------------
		on check_MirrorTool changed state do openOrCloseRollout  "automat_MirrorTool" state
		on check_ModelZipper changed state do openOrCloseRollout  "automat_ModelZipper" state
		on check_SubObjectTools changed state do openOrCloseRollout  "automat_ObjectTools" state
		on check_ImageTool changed state do openOrCloseRollout  "automat_ImageTool" state
		--------------
		on check_ModelDiag changed state do openOrCloseRollout  "automat_ModelDiag" state
		on check_MatSmoothTool changed state do openOrCloseRollout  "automat_MatSmoothTool" state
		on check_Nubbins changed state do openOrCloseRollout  "automat_Nubbins" state
		--------------
		on check_MatchObjectTool changed state do openOrCloseRollout  "automat_MatchObjectTool" state
		on check_ObjCleaner changed state do openOrCloseRollout  "automat_ObjCleaner" state
		on check_ImportExportTools changed state do openOrCloseRollout  "automat_ImportExportTools" state
		--------------
		on but_CloseAll pressed do closeAutomatRollouts()
		--------------

		--------------------------------------------------------
		on check_About changed state do openOrCloseAboutBox state
	
		
		
		--------------------------------------------------------
		on roll_LauncherButtons rolledUp state do
		(
			if false == state then --minimize
			(
				QuietResize = true
				automat_LauncherFloater.size.y = 24
				QuietResize = false
			)
			else
			(
				resizeautomat_LauncherFloater 0
			)	
		)
		
		--/////////////////////////////////////////////
		--------------------------------------------------------
		on roll_LauncherButtons moved ScreenPos do
		(
			setapref =  setINISetting CurrentINI "Rollout Properties" "RolloutPosition" (ScreenPos as string )
		)
		
		on roll_LauncherButtons resized RollSize do
		(
			
			if QuietResize != true do --User Resize
			(
				RolloutMaxY = RollSize.y 
				setapref =  setINISetting CurrentINI "Rollout Properties" "RolloutMaxY" (RolloutMaxY as string )
				if setapref == true do ()
			)
		)
		
		
		

		
	)
	
	

	--------------------------------------------------------
	rollout Roll_AboutAutomat "About Automat"
	(
		
		imgtag img_automat "" bitmap: AutomatImage 
		label Label01 "Automat" pos:[94,15]
		label Label02 "Version" pos:[97,30]
		label label02a "2015.1.4" pos:[94,45]
		label Label03 " 2015 Steve Burke" offset:[0,15]
		hyperlink Label04 "www.burkestudios.com" color: blue address:"http://www.burkestudios.com" \
			align:#center
		label Label06 "additional art, testing,"
		hyperlink Label07 "and support: Dan Burke" color: black address:"http://nukleon.squarespace.com" \
			align:#center
	)
		
	--Functions
	--/////////////////////////////////////////////
	--------------------------------------------------------
	function openOrCloseRollout  scriptname state =
	(
		if true == state then
		(
			try
			(
				scriptfile = (openFile ((getdir #userScripts) + "\\BurkeStudios\\scripts\\" + scriptname + ".ms"))
			
				if not ( keyboard.controlPressed ) then 
				(
					automat_OpenScriptAsRollout = true
					execute scriptfile
					automat_OpenScriptAsRollout = false
					--------------
					execute ( "addRollout roll_" + scriptname + " automat_LauncherFloater" )
					--------------
					execute ( "automat_ThisRollotY = roll_" + scriptname + ".height" )
					
					numopenrollouts += 1
					
				)
				else
				(
					automat_OpenScriptAsRollout = true
					execute scriptfile
					automat_OpenScriptAsRollout = false
					--------------
					execute ( "addRollout roll_" + scriptname + " automat_LauncherFloater" )
					--------------
					execute ( "automat_ThisRollotY = roll_" + scriptname + ".height" )
					
					
-- 					automat_OpenScriptAsRollout = false
-- 					
-- 					--execute ( "struct_FloatStates." + scriptname + " = true" )
-- 					format "struct_FloatStates: %\n" struct_FloatStates
-- 					struct_FloatStates.automat_JumbleTool = true
-- 					
-- 					automat_ThisRollotY = -24
-- 					
-- 					execute scriptfile
-- 					
				)
			)
			catch
			(
				message = "There was a problem opening the following file:\n\n" + ((getdir #userScripts) + "\\BurkeStudios\\scripts\\" + scriptname + ".ms") 
				messagebox message
				automat_ThisRollotY = 0
			)
			
			QuietResize = true
			resizeautomat_LauncherFloater ( automat_ThisRollotY + 24 )
			QuietResize = false
			
				
			
		)
		else
		(
			numopenrollouts -= 1
			
			execute ( "automat_ThisRollotY = roll_" + scriptname + ".height" )
			execute ( "removeRollout roll_" + scriptname + " automat_LauncherFloater" )
			QuietResize = true
			resizeautomat_LauncherFloater ( -automat_ThisRollotY - 24 )
			QuietResize = false
			
			
		)
	
	)
	
	
	--------------------------------------------------------
	function resizeautomat_LauncherFloater automat_ThisRollotY =
	(
		rollcurrent = automat_LauncherFloater.size.y
		
		RollTarget += automat_ThisRollotY
		
		--reset max Y if it no longer makes sense
		if RolloutMaxY <= rollmin and ( automat_LauncherFloater.rollouts.count > 1 ) do RolloutMaxY = 780		
		
		if RollTarget > RolloutMaxY then newsize = RolloutMaxY
			else if RollTarget < rollmin then newsize = rollmin
				else newsize = RollTarget
				
		QuietResize = true
		automat_LauncherFloater.size.y = newsize
		QuietResize = false
			
		if 0 == numopenrollouts then roll_LauncherButtons.but_CloseAll.enabled = false
			else roll_LauncherButtons.but_CloseAll.enabled = true
	
	)
	
	
	--
	
	
	function openOrCloseAboutBox state =
	(
		if true == state then
			(
				getAutomatImage()
				addRollout Roll_AboutAutomat automat_LauncherFloater
				automat_ThisRollotY = Roll_AboutAutomat.height +24
				numopenrollouts += 1
			)
			else
			(
				automat_ThisRollotY = ( -1*( Roll_AboutAutomat.height + 24 ) )
				removeRollout Roll_AboutAutomat automat_LauncherFloater
				numopenrollouts -= 1
			)
			resizeautomat_LauncherFloater ( automat_ThisRollotY )
	)
	
	--
	
	
	function closeAutomatRollouts =
	(
		
		if roll_LauncherButtons.check_PivotControl.state do openOrCloseRollout  "automat_PivotControl" ( roll_LauncherButtons.check_PivotControl.state = false )
		if roll_LauncherButtons.check_ImageBar.state do openOrCloseRollout  "automat_ImageBAR" ( roll_LauncherButtons.check_ImageBar.state = false )
		if roll_LauncherButtons.check_SpinScatter.state do openOrCloseRollout  "automat_SpinScatter" ( roll_LauncherButtons.check_SpinScatter.state = false )
		--
		if roll_LauncherButtons.check_MirrorTool.state do openOrCloseRollout  "automat_MirrorTool" ( roll_LauncherButtons.check_MirrorTool.state = false )
		if roll_LauncherButtons.check_ModelZipper.state do openOrCloseRollout  "automat_ModelZipper" ( roll_LauncherButtons.check_ModelZipper.state = false )
		if roll_LauncherButtons.check_SubObjectTools.state do openOrCloseRollout  "automat_ObjectTools" ( roll_LauncherButtons.check_SubObjectTools.state = false )
		if roll_LauncherButtons.check_ImageTool.state do openOrCloseRollout  "automat_ImageTool" ( roll_LauncherButtons.check_ImageTool.state = false )
		--
		if roll_LauncherButtons.check_ModelDiag.state do openOrCloseRollout  "automat_ModelDiag" ( roll_LauncherButtons.check_ModelDiag.state = false )
		if roll_LauncherButtons.check_MatSmoothTool.state do openOrCloseRollout  "automat_MatSmoothTool" ( roll_LauncherButtons.check_MatSmoothTool.state = false )
		if roll_LauncherButtons.check_Nubbins.state do openOrCloseRollout  "automat_Nubbins" ( roll_LauncherButtons.check_Nubbins.state = false )
		--
		if roll_LauncherButtons.check_MatchObjectTool.state do openOrCloseRollout  "automat_MatchObjectTool" ( roll_LauncherButtons.check_MatchObjectTool.state = false )
		if roll_LauncherButtons.check_ObjCleaner.state do openOrCloseRollout  "automat_ObjCleaner" ( roll_LauncherButtons.check_ObjCleaner.state = false )
		if roll_LauncherButtons.check_ImportExportTools.state do openOrCloseRollout  "automat_ImportExportTools" ( roll_LauncherButtons.check_ImportExportTools.state = false )
		if roll_LauncherButtons.check_About.state do openOrCloseAboutBox ( roll_LauncherButtons.check_About.state = false )
		--
		
	)
	
	--LOAD PREFS
	--------------------------------------------------------
	getapref = execute ( getINISetting CurrentINI "Rollout Properties" "RolloutMaxY" )
	if getapref != OK do
	(
		RolloutMaxY = getapref
		--may add messagebox if size is too small
	)
	--
	getapref = execute ( getINISetting CurrentINI "Rollout Properties" "RolloutPosition" )
	if getapref != OK do RolloutPosition = getapref
	
	

	--------------------------------------------------------
	
	
	--------------------------------------------------------
	try (closeRolloutfloater automat_LauncherFloater) catch ()
	automat_LauncherFloater = newRolloutFloater "Automat" 170 RollDefaultY RolloutPosition.x RolloutPosition.y
	
	addRollout roll_LauncherButtons automat_LauncherFloater
	

)